	  #!/bin/bash
	  # lancement de l'interpréteur wish\
	  exec wish "$0" "${1+"$@"}"
	  
	  
	  #_______________________________________________________________________________
	  #									 JVSeditor 1.4 mars 20242006 - daniel MACOUIN
	  # _______________________________________________________________________________
	  
	  # JVSeditor est un éditeur de code JavaScript écrit en TCL-TK
	  # auteur : daniel MACOUIN
	  
	  # Cet éditeur est basé sur le code de Tikeditor du même auteur.
	  
	  # TKV(visionneuse) de Jan NIJTMANS  - j.nijtmans@chello.nl
		# modifiée par daniel Macouin pour TikEditor.
	
		  
	  #------------------------------------------------------------------------------------------
	  
	  # Ce programme est un logiciel libre : sans obligation ni pour vous ni pour moi
	#comme une partie du code doit être sous licence GNU, je suppose que 
	  # vous pouvez le redistribuer et/ou le modifier conformément aux dispositions
	  # de la Licence Publique Générale GNU,
	  # telle que publiée par la Free Software Foundation ; version 2 de la licence,
	  
	  # Ce programme est distribué dans l'espoir qu'il sera utile,
	  # mais SANS AUCUNE GARANTIE ;
	  # sans même la garantie implicite de COMMERCIALISATION ou
	  # D'ADAPTATION A UN OBJET PARTICULIER.
	  # Pour plus de détail, voir la Licence
	  # Publique Générale GNU.
	
	  # Tikeditor version 1.0 - mai 2004 / novembre 2004 - daniel MACOUIN
	 # Tikeditor version 3.x - décembre 2005  - daniel MACOUIN
	  
	  #-------------------------------------------------------------------------------------------
	  
		  
	  # la ligne suivante [package require Tk] sert à tester l'évaluation Tcl si vous ne le faites pas avec wish ;
	
		package require Tk
	
	set Chemin(abs) [pwd]
	  set NomScript [info script]
	  set Chemin(rel) [file dirname $NomScript]
	
	#-------------------------------------------------------------------------------------------
	# lancement d'une fenêtre d'attente de chargement
	toplevel .initiation -background bisque -borderwidth 5 -relief raise 
	wm  geometry .initiation 235x315+400+250 
	wm overrideredirect .initiation 1
		raise .initiation
		
	text .initiation.t -foreground purple -font {courier 20} -wrap char -width 15 -height 15 -bg bisque
	pack .initiation.t  -expand true -fill both
	.initiation.t insert end "JSeditor\npour du \nlangage \nJavaScript"
	bind .initiation <Enter> {destroy .initiation}
	
  	set tikimg [image create photo -file  $Chemin(rel)/images/vertige.gif ] 
 	.initiation.t image create end -image $tikimg -align center
		
	#------------------------------------------------------------------------------------------
	
	
	  
	
	#<VariablesGlobales>
	#Chargement des fichiers annexes
		#pour le html : Simple HTML display library by Stephen Uhler (stephen.uhler@sun.com)
		source [file join $Chemin(rel) tikhtmllib.tcl]
		
		#accès à la visionneuse
				source [file join $Chemin(rel)  TikVision.tcl]

		
		global Home
		global Url
		
		global Size
		set Size 0
		


				
		global numeroMarque
		set numeroMarque "0"
		
		global numeroMasque 
		set numeroMasque "0"
		
		global systeme
		set systeme $tcl_platform(platform)
		
		global marquesActuelles 
		set  marquesActuelles {"" maMarqueTest}
		
		set i 0
		while {$i <100} {
		global lignesChoisies$i 
		set  lignesChoisies$i [list 10 20 30 40 55]
		incr i
		}
		
		global widpage
		set widpage 0
		
		global mesMots
		set mesMots "" 
		
		global couleurMesMots
		set couleurMesMots SteelBlue 
		
			
	  set numeroPage 0
	  global widtexte
	  set widtexte .$numeroPage
	  global listeTextes
	  global numPage
	  namespace eval JVSeditor {
		
		#variables globales
		global choixMarque
		global numeroPage
		global listeTextes
			set listeTextes [list "page : $numeroPage"]
		global widtexte
			set widtexte initial
			global NomScript
			set NomScript [info script]
		global Chemin(rel)
		set Chemin(rel) [file dirname $NomScript]
		global flagNumero
		global indexProc1
		global indexProc2
		
		global police
		global taillePolice	
		
		variable balises 
		set balises 0	
		variable lignesChoisies ""
		
		 global numPage
		set numPage 1
				
		##########################################################
	#<version>
		variable version  "1.4"
		
		##########################################################
		
		variable application "JVSeditor"
			
		variable ausujetdeDM { "--------------------"\
			"Daniel MACOUIN" \
			 "daniel.macouin@aliceadsl.fr" \
			  "http://www.danielmacouin.chez.tiscali.fr" \
			  "Mai 2004 / février 2006 / mars 2024"\
						"--------------------"\
			 	}
			
		variable ausujetdeJN { "(visionneuse TKV)>>" \
		"Jan NITJMANS" "j.nijtmans@chello.nl" \
				"--------------------"\
				 }
				variable ausujetdeSUCF {  "documentation Javascript Jean Christophe Beunier  http://jchr.be/html/javascript.htm"\
		
		 }
			
#£ 		variable ausujetdeSUCF {  "(routines html2)>>" "Stephen Uhler" "stephen.uhler@sun.com"  \
#£ 						"Clif Flynt" "clif@cflynt.com"\
#£ 		
#£ 		 }
			


		
		variable motRecherche
		variable fichier
		variable types {
		  {{Fichier JavaScript} {.js}} {{Fichier Texte} {.txt}} {{Tout fichier } {.*}}
		}
		
		variable cheminAcrobat 0
		variable cheminVisionneuse 0
		variable travailencours 0
		variable permute
		
		variable langage
		variable listLang
		variable motscles
		variable indexTampon 0
		
		
#<MOTCLES>	 
		# ces mots clefs servent à la colorisation du script
		# la colorisation des crochets, parenthèses et accolades est assurée par Ctext
		set motscles(controle) [ list for if else switch while  ] 
		set motscles(objet) [ list document  value form window Array new ]
		set motscles(attribut) [ list  border-bottom border-bottom-color border-bottom-style border-bottom-width \
		border-color border-left border-left-color border-left-style border-left-width]
		set motscles(methode) [ list abs acos anchor asin atan atan2 ceil charAt charCode compile concat  join split ] 
		set motscles(evenement) [ list onAbort onBlur onChange onDblClick onDragDrop onError onFocus onKeyDown \
			onKeyPress onKeyUp onLoad onMouseDown onMouseMove onMouseOut onMouseOver OnmouseUp \
			onMove onReset onSelect OnSubmit onUnload] 
				
		variable debut
		variable fin
		variable couleur
		
		# définition des couleurs au chargement et de la taille de la police.
		
		# couleur de "balises"
		set couleur(0) violet
		
		#  couleur de fonction
		set couleur(1) red
		
		# couleur de variable
		set couleur(2) darkblue
		
		# couleur de tcl
		set couleur(3) red
		
		# couleur de tk
		set couleur(4) purple 
		
		#couleur de options Tk
		set couleur(5) hotPink4
		
		# couleur de commentaire
		set couleur(6) darkgreen
		
		# fond
		set couleur(fond) white
		
		# couleur de curseur
		set couleur(curseur) black
		
		# taille de la police
		set taillePolice 12
		
		#nom de la police
		set police helvetica
		
		variable ListeRecents {}
		variable ListeOccurences {}
		
		
	  }
	  
	  
	  
proc JVSeditor::AfficherOctets { etiquette } {
global numeroPage
		global listeTextes
		global widtexte
		variable couleur
		global police
		global taillePolice
		variable fichier
		$etiquette configure -text "[ file size $fichier ] octets"
	  }
	  
	
#<PAGES_BiScrolling_NumPage>
	#	double scrollText
	# les fonctions de scrolling

	# la fonction appelée par les widgets scroolés
proc yset  {args} {	
global numPage

#£ 		eval [linsert $args 0 .ftext.sy$numPage set ]
#£ 		yview moveto [lindex [.ftext.sy$numPage get ] 0]
	}
	
	
	# la fonction appelée par la scrollbar OK
proc yview  {args} {
global numPage

	eval [linsert $args 0 .ftext.$numPage yview]
			eval [linsert $args 0 .ftext.${numPage}lignes yview] 
		}
		

	
proc JVSeditor::NouvellePage {choix} {
		global numeroPage
		global listeTextes
		global widtexte
		variable couleur
		global police
		global taillePolice
		global numPage
		
		# désaffichage de la fenetre précédente
		for {set i 0} {$i < $numeroPage} {incr i} {
		  pack forget .ftext.$i
		  pack forget .ftext.${i}lignes
		  pack forget .ftext.sy$i
		  pack forget .ftext.sx$i
		}

	  
		
# l'interface

	text .ftext.$numeroPage -bg $couleur(fond)  -wrap none -tabs {1c}\
			-xscrollcommand ".ftext.sx$numeroPage set" -yscrollcommand yset -undo 1 
			
	text 	.ftext.${numeroPage}lignes -width 4 -bg ivory -wrap none	-yscrollcommand yset -relief sunken
	
			
		scrollbar .ftext.sx$numeroPage -orient horizontal -command ".ftext.$numeroPage xview"
		scrollbar .ftext.sy$numeroPage -orient vertical -command  ".ftext.$numeroPage yview"
		
		pack .ftext.sx$numeroPage -fill x -side bottom
		pack .ftext.sy$numeroPage -fill y -side right
		pack .ftext.${numeroPage}lignes -fill y  -side left	
		pack .ftext.$numeroPage 	-fill both	-expand true -side left
		
				

		# on affecte la configuration police à la fenêtre
		 .ftext.$numeroPage configure -font  "[list $police]  $taillePolice"
		
		# on configure l'option wrap de la colonne des numéros pour empêcher le décalage
		 .ftext.${numeroPage}lignes configure -wrap none -font "[list $police]  $taillePolice"
		
		set listeTextes [lappend listeTextes "page : $choix" ]
		
		
		# on affecte la nouvelle valeur à "widtexte" pour désigner la fenetre en cours
		set widtexte ".ftext.$numeroPage"
		
 		set numPage [lindex [split $widtexte \. ] 2 ] 
		
				
		# on "bind" la page sur bouton3 pour afficher menu "editer"
		bind $widtexte <3> { tk_popup .menubar.mEditer %X %Y }
		
		# on met à jour le menu Pages
		.menubar.mPages	 add radio -label "page : $choix"  -command " JVSeditor::Affiche  $numeroPage $choix "
						
		# on incrémente le numéro de page pour la prochaine page à ouvrir
		incr numeroPage
		
		.fetat.fichier configure -text "$choix"
		
		JVSeditor::NumeroLignesTexte $widtexte
		
		
	  }
	  
	  
proc JVSeditor::Affiche { num nomFichier} {
		global numeroPage
		global widtexte
		variable fichier
		
		
		variable lignesChoisies$widtexte 1

		
		for {set i 0} {$i < $numeroPage} {incr i} {
		  pack forget .ftext.$i
		  pack forget .ftext.sy$i
		  pack forget .ftext.sx$i
		}
		
		pack .ftext.sy$num -fill y -side right
		pack .ftext.$num -expand true	-fill both
		pack .ftext.sx$num -fill x -side top
		
		set widtexte .ftext.$num
		set fichier 	$nomFichier
		.fetat.fichier configure -text "$nomFichier"
		
			bind $widtexte <3> { tk_popup .menubar.mEditer %X %Y }
		
		
	  }
	  
proc JVSeditor::Nouveau {} {
		global Chemin
		variable application
		variable fichier
		variable types
		global widtexte
		global numeroPage
		
		if {[string compare $widtexte .ftext.0 ]!=0} {
		  set dialogue [tk_dialog .top "nouveau..." "Vous devriez sauvegarder le fichier en cours.\nSauvegarder?" questhead 0 OUI NON Annuler]
		  
		  
		  switch $dialogue {
			0 { JVSeditor::Sauvegarder $widtexte 1}
			1 {}
			2 {return}
		  }
		}
		
		JVSeditor::NouvellePage "PageNouvelle.$numeroPage"
	  }
	  
proc JVSeditor::Ouvrir {} {
		global Chemin
		global numeroPage
		variable application
		variable fichier
		variable types
		global widtexte
		
		
		if { [string compare  [set choix [ tk_getOpenFile -title "$application : 0uvrir"\
			-initialdir $Chemin(rel) -filetypes $types] ] "" ]== 0} {
						tk_messageBox -message "vous n'avez pas ouvert de fichier"
						; return
		}
		
		# ouverture d'une nouvelle fenetre
		JVSeditor::NouvellePage $choix
		
		if [ string compare $choix "" ] {
		  set resultat [ JVSeditor::ChargerTexte $widtexte $choix ]
		  if { $resultat == 0 } {
			set fichier $choix
			JVSeditor::Recents $choix
			JVSeditor::MiseAJour $widtexte
		  }
		}
		.fetat.fichier configure -text $choix
		
		JVSeditor::NumeroLignesTexte $widtexte
	  }
	  
	  
proc JVSeditor::Fermer { widtexte } {
		
				
		#on récupère le numéro de la fenetre
		set splitWidtexte [split $widtexte .]
		set num [lindex $splitWidtexte 2]
			
		
		# on détruit la fenetre en cours
		if {$num != 0} {
		  destroy $widtexte
		
		
		 # on ferme les scrollbars relatifs à cette fenetre texte
 		   destroy .ftext.sy$num
 		 destroy .ftext.sx$num

		  
		  # on met à jour le menu Pages
				
		.menubar.mPages entryconfigure [expr $num+1] -state disabled   
		  
		  JVSeditor::Affiche 0 defaut
		  
		}
	  }
	  
proc JVSeditor::Sauvegarder { widtexte flag } {
		global Chemin
		variable application
		variable fichier
		variable types
		#flag :1 sauvegarder sous
		
		#on récupère le numéro de la fenetre
		set splitWidtexte [split $widtexte .]
		set pageIndex [lindex $splitWidtexte 2]
		
		
		
		if {$flag==1} {
		  set choix [ tk_getSaveFile \
		-title "$application : Sauvegarder sous" -defaultextension .tcl -filetypes $types] ;
		set fichier $choix
		} else {
		  if [catch {set choix $fichier}] {
			tk_messageBox -type ok -icon warning \
				-message "Aucun fichier n'a encore été défini, utilisez :\n\"Sauvegarder\
				sous\"."
			return
		  }
		}
		
		if {$choix==""} {
		  tk_messageBox -type ok -icon warning \
			  -message "Erreur d'écriture ... le fichier n'a pas été enregistré."
		} else {
			
			set dossier [regexp $Chemin(abs) $choix	]
		 	if {$dossier == 1} {
		
			tk_messageBox  -icon error -type ok  -message  "Vous ne pouvez pas enregistrer\
		 dans le dossier de $Chemin(abs)\
		C'est celui du programme en cours"
		
		return
		
		}
		
		  set idf [open $choix w]
		  set contenu [ $widtexte get 1.0 end ]
		  puts -nonewline $idf $contenu
		  close $idf
		  set fichier $choix
		  
		  JVSeditor::AfficherOctets .fetat.taille
		  
		  if {$flag==1} {
			JVSeditor::MiseAJour $widtexte
			.fetat.fichier configure -text $choix
			# on met à jour le menu Pages
			.menubar.mPages	 delete [expr $pageIndex+1 ]
			.menubar.mPages insert [expr $pageIndex+1 ] radiobutton -label "page : $choix"  -command " JVSeditor::Affiche  $pageIndex $choix "
			
			
		  }
		}
		
		
	  }
	  
	  
proc JVSeditor::MiseAJour { widtexte } {
		variable application
		variable version
		variable fichier
		variable langage
		
		set langage [ string range [file extension $fichier] 1 end]
		wm title . "$application version $version "
		JVSeditor::OuvrirFicLang
		#JVSeditor::Coloration $widtexte 1
		JVSeditor::AfficherOctets .fetat.taille
		JVSeditor::NbLignes $widtexte .fetat.nblignes
	  }
	  
proc JVSeditor::ChargerTexte { widtexte choix } {
		variable application
		variable motscles
		if [ catch { open $choix } FIC ] {
		  tk_messageBox -type ok -icon warning \
			  -message "Impossible d'ouvrir le fichier $choix"
		  return 1
		} else {
		  $widtexte delete 0.0 end
		  set contenu [ read -nonewline $FIC ]
		  regsub -all {\ {4}} $contenu "\t" contenu
		  $widtexte insert 0.0 $contenu
		   		
		  close $FIC
		  return 0
		}
		
		.fetat.fichier configure -text $choix
	  }
	  
  
proc JVSeditor::Imprimer { widtexte} {
global systeme

		
	# impression d'un bloc sélectionné
	# ou de tout le texte par défaut
	
	set ranges [ $widtexte tag ranges sel ]
	
	if { [llength $ranges] == 0 } { 
			set contenu [$widtexte get 1.0 end]
	}   else {		
	set i1 [ lindex $ranges 0 ]
	set i2 [ lindex $ranges 1 ]
	set contenu [ $widtexte get $i1 $i2 ]
	}
	
	# la commande unix lpr imprime un fichier
	# il fautdonc sauver temporairement le contenu du texte dans un fichier,
	# l'imprimer,
	# et le détruire après.

	set tempo [open "[pwd]/temp.txt" w+ ]
	puts $tempo $contenu 
	close $tempo
	
	# commande en fonction des systèmes unix ou windows
	switch $systeme unix {
		exec lpr "[pwd]/temp.txt" }
	switch $systeme windows {
		 tk_messageBox -message "Votre texte s'affiche dans le Bloc-note\nUtilisez sa fonction \"imprimer\" " 
		exec notepad	"[pwd]/temp.txt"} 
		
 	file delete "[pwd]/temp.txt"
	
	}
		
	
proc JVSeditor::ToutSelectionner { widtexte } {
		$widtexte tag add sel 0.0 end
	  }
	  
proc JVSeditor::Defaire { widtexte } {
		catch {$widtexte edit undo}
	  }
	  
	  
proc JVSeditor::Refaire { widtexte } {
		catch {$widtexte edit redo}
	  }
	  
	  
proc JVSeditor::Copier { widtexte } {
		set ranges [ $widtexte tag ranges sel ]
		if { [llength $ranges] == 0 } { return }
		set i1 [ lindex $ranges 0 ]; set i2 [ lindex $ranges 1 ]
		set texte [ $widtexte get $i1 $i2 ]
		clipboard clear
		clipboard append $texte
		return [list $i1 $i2]
	  }
	  
proc JVSeditor::Coller { widtexte } {
		if [ catch { selection get -selection CLIPBOARD } texte ] { return }
		$widtexte insert insert $texte
		JVSeditor::Coloration $widtexte 2
	  }
	  
proc JVSeditor::Couper { widtexte } {
		set coupeZone [ $widtexte tag ranges sel ]
		if { [llength $coupeZone] == 0 } { return }
		set i1 [ lindex $coupeZone 0 ]; set i2 [ lindex $coupeZone 1 ]
		$widtexte delete $i1 $i2
	  }
	 
proc JVSeditor::MasquerSelection {widtexte} { 
		global Chemin
		global numeroMasque 

		# création du bouton de démasquage 
		set imgDemasquer [image create photo -file [file join $Chemin(rel) images masque.gif]]
	
		#masquage du texte sélectionné 		
		set ranges [ $widtexte tag ranges sel ]
		if { [llength $ranges] == 0 } { return
		 } else {
		set i1 [ lindex $ranges 0 ]
		set i2 [ lindex $ranges 1 ]

		$widtexte tag add masque$numeroMasque  $i1 $i2 
		$widtexte tag configure masque$numeroMasque -elide true 
		set numMasque $numeroMasque
		# création du bouton de démasquage 
		button $widtexte.boutonDemasquer$numMasque -image $imgDemasquer  -relief raise -command "JVSeditor::DemasquerSelection $widtexte $numMasque $i1 $i2" -background red	-bd 2 -activebackground green
		bind $widtexte.boutonDemasquer$numMasque   <Enter> "after 50 ; .fetat.message configure -text {>>Démasquer le texte caché} "
		bind $widtexte.boutonDemasquer$numMasque   <Leave> " ; .fetat.message configure -text {} "

		#insertion du bouton de démasquage 
		$widtexte window create $i1 -window $widtexte.boutonDemasquer$numeroMasque -padx 5
		incr numeroMasque
		
		}
		
		return [list $i1 $i2]
}	

proc JVSeditor::DemasquerSelection {widtexte numMasque i1 i2} { 

$widtexte tag remove masque$numMasque $i1 $i2
destroy  $widtexte.boutonDemasquer$numMasque   
.fetat.message configure -text {} 
}

proc JVSeditor::IndentationAuto { widtexte } {
		set position [expr {int([$widtexte index insert])-1}]
		set indice [$widtexte search -forwards -count long\
			-regexp (\\t)* ${position}.0 ${position}.end]
		if {[info exists long]==0} {return}
		set espace ""
		for {set i 1} {$i<=$long} {incr i} {
		  append espace "\t"
		}
		$widtexte insert  [$widtexte index insert] $espace
	  }
	  
proc JVSeditor::Indenter {widtexte} { 
		set contenu [$widtexte get 1.0 end]
		regsub -all {\ {4}} $contenu "\t" contenu
		$widtexte delete 1.0 end
		$widtexte insert 1.0 $contenu
	  }
	  
proc JVSeditor::Quitter {} {
		#JVSeditor::EnregConfig
		JVSeditor::EnregListeRecents
		destroy .
		exit
	  }
	  
proc JVSeditor::Recents {fic} {
		variable ListeRecents
		global Chemin
		variable fichier
		variable types
		global widtexte
		
		if {[lsearch $ListeRecents $fic]!=-1} {return}
		
		set liste [list $fic]
		foreach el $ListeRecents {
		  lappend liste $el
		}
		set ListeRecents [lrange $liste 0 9]
		
		JVSeditor::MaJMenuRecents
	  }
	  
	  
proc JVSeditor::EnregListeRecents { } {
		global Chemin
		variable ListeRecents
		
		set fichier [open [file join $Chemin(rel) JSeditorRecents.rc] w]
		foreach fic $ListeRecents {
		  puts $fichier $fic
		}
		close $fichier
	  }
	  
	  
proc JVSeditor::LectureListeRecents { } {
		global Chemin
		variable ListeRecents
		
		if {![catch {set fichier [open [file join $Chemin(rel) JSeditorRecents.rc] r]}]} {
		  while {![eof $fichier]} {
			set capture [gets $fichier]
			if {$capture!=""} {
			  append ListeRecents " [list $capture]"
			}
		  }
		  close $fichier
		}
	  }
	  
	  
proc JVSeditor::MaJMenuRecents {} {
		variable ListeRecents
		global widtexte
		set Fichier .menubar.mFichier
		
		$Fichier.lRecents delete 0 end
		foreach el $ListeRecents {
		  $Fichier.lRecents  add command -label $el\
			  -command "JVSeditor::OuvrirRecents $el"
		}
		JVSeditor::EnregListeRecents
		
	  }
	  
proc JVSeditor::PurgerRecents {} {
		variable ListeRecents
		global widtexte
		set Fichier .menubar.mFichier
		
		$Fichier.lRecents delete 0 end
		set ListeRecents ""
		JVSeditor::EnregListeRecents
	  }
	  
	  
proc JVSeditor::OuvrirRecents {choix} {
		variable fichier
		global widtexte
		
		# ouverture d'une nouvelle fenetre
		JVSeditor::NouvellePage $choix
		
		set resultat [ JVSeditor::ChargerTexte $widtexte $choix ]
		if { $resultat == 0 } {
		  set fichier $choix
		  JVSeditor::MiseAJour $widtexte
		}
		.fetat.fichier configure -text $choix
		JVSeditor::NumeroLignesTexte $widtexte
	  }
	  
	  
	#VEILLER à changer les noms des mots clés pour adapter à javascript  
proc JVSeditor::OuvrirFicLang { } {
		global Chemin
		variable langage
		variable listLang
				
		if { $langage=="js" } {
		  set listLang {controle objet attribut methode}
		}
		
	  }
	  
	  ###############################################"
	  ### routines couleur
	  ###############################################
	  
	  #l'alternative qui permet de coloriser soit tout le texte, soit ligne par ligne à la saisie, soit un bloc.
	  
proc JVSeditor::ZoneColoration {widtexte flip} { 
		variable debut
		variable fin
		variable tailleBloc
		
		if {$flip == 1} {
		  set debut 1.0
		  set fin end
		} else {
		  set indices [ $widtexte tag ranges sel ]
		  if { [llength $indices] == 0  } {
			set debut [$widtexte index "insert linestart"]
			set fin [$widtexte index "insert lineend"]
		  } else {
			set debut [$widtexte index  [lindex $indices 0]]
			set fin [$widtexte index  [lindex $indices 1]]
			set tailleBloc [expr $fin - $debut ]
			puts $tailleBloc
		  }
		  
		}
	  }
	  
	  
	  
proc JVSeditor::Coloration {widtexte flag } { 
		variable fichier 	; #chemin du fichier ouvert
		
		global Chemin
		
		variable travailencours  ;
		#  0 ou 1 sert à afficher un message dans la barre d'état
		#et à bloquer toute autre action avant la fin de la colorisation syntaxique
		
		variable debut ;
		#début de la zone à coloriser
		
		variable fin ;
		#fin de la zone à coloriser
		
		variable couleur ;
		#valeurs correspondant aux couleurs du panneau de couleurs syntaxiques
		
		variable motscles ;
		# pour javascript il s'agit d'une liste de 5 élements liste: vakeurs : mots-attribut , mots-objet , mots-controle , mots-methodes et mots-évènements
		
		variable langage ;
		#actuellement  <dec 2005> ne prend en compte qu'une valeur :js pour javascript.
		#Pourrait servir si JSeditor servait pour d'autres langages de programmation.
		
		variable listLang ;
		# dans Tikeditor pour langage==TCL, listLang possède trois éléments (valeurs Tcl et Tk et option)
		# dans JSeditor pour langage=javascript , listLang possède 5 éléments : controle objet  attribut  methode évènements
		
		
		if {$travailencours==1} {return}
		
		if  {[ info exists listLang]==0} { return }
		set travailencours 1
		set imgColoration [image create photo -file [file join $Chemin(rel) images greenball.gif]]
		set imgColoration2 [image create photo -file [file join $Chemin(rel) images redball.gif]]
		
		
		
		if {($flag==1) } {
		  .ficones.coloration configure -image $imgColoration2
		  .fetat.message configure -text "Travail de coloration en cours ...  veuillez patienter"
		  $widtexte configure -cursor watch
		  . configure -cursor watch
		  update
		}
		
			
		set DifferentesParties { 0 commentaireMultiligne 1 function  }
		set nb [ llength $listLang ] ;
		#dans le cas du langage javascript  listLang possède 5 éléments attribut objet controle methodes évènementsqui vont se rajouter à la liste différentes parties
		#  on pourrait simplifier tout cela car JSeditor ne taite que javascript, mais comme le code prévoit la possibilité d'autres langagfes,
		#autant le garder pour un avenir d'éventuelle complexité
		
		for { set u 0 } { $u<$nb } { incr u } {
		  
		  set LeLangage [ lindex $listLang $u ]
		  
		  lappend DifferentesParties [ expr {$u+2} ] $LeLangage
		  
		  # construction des expressions régulières
		  # correspondant aux mots clés du langages javascript (controles objets attributs methodes evenements)
		  set ExReg([ expr {$u+2} ]) "("
		  append ExReg([ expr {$u+2} ]) [ string map { " " | } $motscles($LeLangage) ]
		  append ExReg([ expr {$u+2} ]) ")"
		}
		
		
		lappend DifferentesParties [expr {$nb+2}] commentaire
		
		#coloration des accolades et compagnie
		lappend DifferentesParties 7 parentheses 
		set couleur(7) $couleur(2) ; # couleur des fonctions
		
		JVSeditor::ZoneColoration $widtexte $flag ; # appel de la fonction ZoneColoration
		
		# attribution des noms de tags
		# et destruction des tags existants
		foreach {k espece} $DifferentesParties {
		  set nom($k) $espece
		  $widtexte tag remove $espece $debut $fin
		}
		
#<ColorationCommentaires>			
		set finCom "end" 
#£ 		set com(0) { -regexp {\/\*.*\*\/} $debut $fin } ; #commentaires multilignes
		set com(0) { -regexp {\/\*.*\$*\*\/} $debut $fin } ; #commentaires multilignes
#£ 	actuellement innefficace 11/ fev/ 2006, car ne saute pas les lignes
		

		set com(1) { function $debut $fin } ;										 # déclaration de fonction
		set com(2) { -regexp "$ExReg(2)" $debut $fin } ; #controle for if ...
		set com(3) { -regexp "$ExReg(3)" $debut $fin } ; 	# objets: document value 
		set com(4) { -regexp  "\.$ExReg(4)" $debut $fin } ; # attributs		
 		set com(5) { -regexp "\.$ExReg(5)" $debut $fin }  ;  #méthodes exemple join() ou concat() ... 
		set com(6) { -regexp {\s*\/\/.*$} $debut $fin }									; #commentaires 
		
		set com(7) { -regexp {\(|\)|\{|\}|\[|\]} $debut $fin }									; #parenthèses et compagnie 
		
		for {set j 0} {$j<=7} {incr j} {
		  set com($j) "$widtexte search -forwards -count long($j) $com($j)"
		  set i($j) [eval $com($j)]
		}
		
		
		# boucle principale de la recherche des correspondances
		# pour la coloration
		while 1 {
		  
		  if {[join $i(0)$i(1)$i(2)$i(3)$i(4)$i(5)$i(6)$i(7)]==""} { break }
		  set min [lindex [lsort -real "$i(0) $i(1) $i(2) $i(3) $i(4) $i(5) $i(6) $i(7)"] 0]
		  
		  for {set u 0} {$u<=7} {incr u} {
			if {$i($u)==$min} {
			  set k $u
			  break
			}
		  }
		  
		  $widtexte tag add $nom($k) $i($k) "$i($k) + $long($k) char"
		  set debut "$i($k) + $long($k) char"
		  
		  # on ne recalcule que celui qu'on vient d'utiliser
		  set i($k) [eval $com($k)]
		  
		}
		
		for { set k 7 } { $k>=0 } { incr k -1} {
		  $widtexte tag configure $nom($k) -foreground $couleur($k)
		}
		
				
		set travailencours 0
		.fetat.message configure -text ""
		$widtexte configure -cursor arrow
		. configure -cursor arrow
		.ficones.coloration configure -image $imgColoration
		update
	  }
	  
	  
	  
	  ##########################
	  # Couleurs et préférences
	  ##########################
	  
	  
proc JVSeditor::Couleurs { } {
		variable couleur
		global widtexte
		
		destroy .fenCoul
		toplevel .fenCoul
		bind .fenCoul <3> {destroy .fenCoul}
		wm title .fenCoul "JVSeditor Choix des couleurs"
		wm resizable .fenCoul false false
		
		set Coul " Balises 0	Function 1  Controles 2 Objets 3 Attributs 4 Méthodes 5 Commentaire 6 Fond fond Curseur curseur"
		foreach {chose cle} $Coul {
		  pack [button .fenCoul.$cle -text $chose -width 25 -bg $couleur($cle)\
			  -command "JVSeditor::ModCouleur $cle" ]
		}
	
	label .fenCoul.separe -text " les changements fond et curseur\n s'appliquent immédiatement."
	pack  .fenCoul.separe -before .fenCoul.fond
		button .fenCoul.ok -text "Valider" -width 10 -command "JVSeditor::Coloration $widtexte 1" -background grey -foreground black
		button .fenCoul.fermer -text "Fermer" -width 10 -command "destroy .fenCoul" -background grey -foreground black
		
		button .fenCoul.defaut -text "Réinitialiser"\
			-width 10	-command "JVSeditor::ModCouleur defaut " -background grey -foreground black
		pack .fenCoul.ok .fenCoul.defaut   .fenCoul.fermer -side left -expand 1 -fill x
	  }
	  
proc JVSeditor::ModCouleur {cle} {
		variable couleur
		global widtexte
		
		if {$cle=="defaut"} {
		  # balises
		  set nouvellecouleur red
		  set couleur(0) $nouvellecouleur
		  # proc
		  set nouvellecouleur red
		  set couleur(1) $nouvellecouleur
		  # variable
		  set nouvellecouleur darkblue
		  set couleur(2) $nouvellecouleur
		  # tcl
		  set nouvellecouleur blue
		  set couleur(3) $nouvellecouleur
		  # tk
		  set nouvellecouleur chocolate
		  set couleur(4) $nouvellecouleur
		  #options tk
		  set nouvellecouleur violet
		  set couleur(5] $nouvellecouleur
		  # commentaire
		  set nouvellecouleur darkgreen
		  set couleur(6) $nouvellecouleur
		  # fond
		  set nouvellecouleur white
		  set couleur(fond) $nouvellecouleur
		  $widtexte configure -bg $nouvellecouleur
		  # curseur
		  set nouvellecouleur black
		  set couleur(curseur) $nouvellecouleur
		  $widtexte configure -fg $nouvellecouleur -insertbackground $nouvellecouleur
		  
		  #fermeture de la boite et mise à jour de la colorisation du texte
		  destroy .fenCoul
		  JVSeditor::Coloration $widtexte 1
		  return
		  
		} else {
		  set nouvellecouleur [tk_chooseColor -initialcolor $couleur($cle) -parent .fenCoul\
			  -title "Choisir une couleur"]
		  
		  if {$nouvellecouleur==""} {destroy .fenCoul ; return }
		  set couleur($cle) $nouvellecouleur
		  
		  if {$cle=="fond"} {
			$widtexte configure -bg $nouvellecouleur
		  } elseif {$cle=="curseur"} {
			$widtexte configure -fg $nouvellecouleur -insertbackground $nouvellecouleur
		  } else {
			$widtexte tag configure $cle -foreground $nouvellecouleur
		  }
		}
		.fenCoul.$cle configure  -bg $nouvellecouleur
		
		#fin de la fonction modCouleur
	  }
	  
proc JVSeditor::BarreEtat {position } {
		global widtexte
		switch $position {
		  "haut" {pack .fetat  -before .ftext -fill both}
		  "bas" {pack .fetat  -after .ftext -fill both}
		} }
	  
proc JVSeditor::RetourLigne  {wrap } {
		global widtexte
		switch $wrap {
		  "none" {$widtexte configure -wrap none -background  white }
		  "word" {$widtexte configure -wrap word -background ivory}
		  "char" {$widtexte configure -wrap char -background #bcc0e0	   }
		} }
	  
proc JVSeditor::PolicePlus {widtexte} {

	global taillePolice
		
		set i "[lindex [$widtexte cget -font] 1 ]"
		set j "[ list [lindex [$widtexte cget -font] 0 ] ]"
		incr i
		$widtexte configure -font "$j $i"
		
		set taillePolice $i
		
		JVSeditor::DetagBalises $widtexte
	  }
	  
proc JVSeditor::PoliceMoins {widtexte} {
		
	global taillePolice
	
		set i "[lindex [$widtexte cget -font] 1]"
		set j "[ list [lindex [$widtexte cget -font] 0 ] ]"
		incr i -1
		if {$i <2} { set i 2}
		
		$widtexte configure -font "$j $i  "
		
		set taillePolice $i
		
		JVSeditor::DetagBalises $widtexte
		
	  }
	
proc JVSeditor::PolicePlusAide {widtexte} {
		global Size
		incr Size
		
HMset_state $widtexte -size $Size
	  }
	  
proc JVSeditor::PoliceMoinsAide {widtexte} {
		global Size		
		incr Size -1
 HMset_state $widtexte -size $Size
	  }
	  
	  
	  
proc JVSeditor::ChoixFonte {} {
		global police
		global taillePolice
		global widtexte
		
		destroy .fonte
		toplevel .fonte
		wm title .fonte "FONTE pour  JVSeditor"
	
		wm resizable .fonte false false
		
		
		frame .fonte.f  -relief raised 
		frame .fonte.f.ico -bg SteelBlue
		
		pack .fonte.f  -expand false -fill y
		pack .fonte.f.ico -fill x
		
		button .fonte.f.ico.plus -text "+" -command { incr taillePolice ; .fonte.f.tp configure -font "[list $police]  $taillePolice " } -font {-size 12}
		button .fonte.f.ico.moins -text "-" -command { incr taillePolice  -1; .fonte.f.tp configure -font "[list $police]  $taillePolice "  } -font {-size 12}
		button .fonte.f.ico.okT  -text valider -command { $widtexte configure -font "[list $police]  $taillePolice " } -font {-size 12}
		
		spinbox .fonte.f.ico.nomFonte -text "nom de fonte" -relief raised -bd 3  -values [font families]\
			-textvariable police -command  {.fonte.f.tp configure -font "[list $police]  $taillePolice "}  -font {-size 12}
		button .fonte.f.ico.okP -text valider -command { $widtexte configure -font "[list $police]  $taillePolice " } -font {-size 12}
		
		label .fonte.f.ico.lP -text POLICE  -relief flat -bd 0 -bg SteelBlue -fg yellow -font {-size 12}
		
		spinbox .fonte.f.ico.sp -text police -relief raised -bd 3 -width 3  -from 6 -to 30 -incr 2 -textvariable taillePolice -command  {.fonte.f.tp configure -font "[list $police]  $taillePolice "}
		label .fonte.f.ico.l -text CorpsFonte  -relief flat -bd 0 -bg SteelBlue -fg yellow -font {-size 12}
		
		pack  .fonte.f.ico.l  .fonte.f.ico.plus  .fonte.f.ico.moins .fonte.f.ico.sp  .fonte.f.ico.okT	.fonte.f.ico.lP  .fonte.f.ico.nomFonte  .fonte.f.ico.okP  -side left -fill y
		
		text .fonte.f.tp -bg AntiqueWhite -font [list $police]  -relief sunken  -wrap char -height 5 -width 15 
		pack .fonte.f.tp -fill both -expand 1
		.fonte.f.tp insert end "Ceci est un texte pour essayer les fontes \nabcdefghijklmnopqrstuvwyz\nABCDEFGHIJKLMNOPQRSTUVWXYZ"
		
		.fonte.f.ico.nomFonte delete 0 end
		.fonte.f.ico.nomFonte insert end  "[ list [lindex [$widtexte cget -font] 0 ] ]"
		.fonte.f.ico.sp delete 0 end
		.fonte.f.ico.sp insert end "[lindex [$widtexte cget -font] 1]"
		
		bind .fonte <3> { destroy .fonte }
		
	  }
	  
	  
	  
	  ##########################
	  # aides programmeur Tcl/Tk
	  ##########################
	  
	  
 
proc JVSeditor::Visionneuse {} {
			if {[winfo exists .jvsEvisio]==1} {
			raise .jvsEvisio } else {
			 image_window .jvsEvisio }
			} 
	  
proc JVSeditor::ExpressionReguliere {} {
		variable couleur
		global Chemin
		destroy .topRG
		# création d'une fenêtre pour les expressions régulières
		toplevel .topRG
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topRG +[expr ${largeurEcran}/2]+60
		text .topRG.fenRG -wrap word  -bg skyblue  -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 10"	-yscrollcommand ".topRG.sy set" -relief groove  -cursor "hand1"
		scrollbar .topRG.sy -orient vertical -command ".topRG.fenRG yview" -cursor hand2
		
		pack .topRG.sy -fill y -side left
		pack .topRG.fenRG -expand false -fill both -side left
		
		
		set Aexpreg [file join $Chemin(rel) aideRG.txt ]
		set FIC [open $Aexpreg RDWR]
		
		.topRG.fenRG delete 0.0 end
		set contenu [ read -nonewline $FIC ]
		regsub -all {\ {4}} $contenu "\t" contenu
		.topRG.fenRG insert 0.0 $contenu
		close $FIC
		.topRG.fenRG configure -state disabled
		bind .topRG <3> {destroy .topRG}
		
	  }
	  
	  ################################################################################
	  #<BALISES_TIK>
	  ################################################################################
	  # des tags pour les balises : en fonction du mot clé entré en tête de balise, 
	  # l'affichage de la balise se fera selon une casse différente (fonction: JVSeditor::TagBalises)
	  # 
	  # La fonction est réversible à tous moments.(fonction: JVSeditor::DetagBalises)
	


proc JVSeditor::NumeroLignesTexte {widtexte} {
	variable balises
		${widtexte}lignes delete 1.0 end
${widtexte}lignes insert 1.0 "1"
	for {set i 2} {$i< [lindex [$widtexte index end] 0] } {incr i } {
	
	${widtexte}lignes insert end "\n$i" 
	}
	if {$balises == 1 } {
	JVSeditor::TagBalises $widtexte
		}
		
		${widtexte}lignes configure -width  [string length [lindex [split [$widtexte index end] \.] 0] ] 
	}

proc JVSeditor::AlterneBalises { widtexte } {
variable balises
variable couleur

if {$balises==1} {set balises 0; .ficones.tagbalises configure -background white ;JVSeditor::DetagBalises $widtexte 
} else { set balises 1; .ficones.tagbalises configure  -background $couleur(0) ;JVSeditor::TagBalises $widtexte }
}

proc JVSeditor::TagBalises { widtexte } {
global police
global taillePolice
variable couleur 


${widtexte}lignes configure -font "$police $taillePolice"


# lignes pour tags "balisesSpécialesTik" dans le texte
	$widtexte tag configure T1 -font { $police 20 bold} -foreground $couleur(0)
	$widtexte tag configure T2 -font { $police 16 bold} -foreground $couleur(0)
	$widtexte tag configure T3 -font { $police 14 } -foreground $couleur(0)
	$widtexte tag configure T4 -font { $police 12 bold italic} -foreground $couleur(0)
	$widtexte tag configure T5 -font { $police 10 italic} -foreground $couleur(0)
	
# lignes pour tags "balisesSpécialesTik" dans la colonne des numéros

	${widtexte}lignes tag configure T1 -font { $police 20 bold} -foreground $couleur(0)
	${widtexte}lignes tag configure T2 -font { $police 16 bold} -foreground $couleur(0)
	${widtexte}lignes tag configure T3 -font { $police 14 } -foreground $couleur(0)
	${widtexte}lignes tag configure T4 -font { $police 12 bold italic} -foreground $couleur(0)
	${widtexte}lignes tag configure T5 -font { $police 10 italic} -foreground $couleur(0)
	
	variable tagBalise [list T1 T2 T3 T4 T5]
set i 1
	foreach tagTitre $tagBalise {
	
		set debut 1.0	
		while 1 { 		
		switch $tagTitre {
		T1 {	set balise "//<T1>" }
		T2 {	set balise "//<T2>" }
		T3 {	set balise "//<T3>" }
		T4 {	set balise "//<T4>" }
		T5 {	set balise "//<T5>" }
		}
		
		set indice [$widtexte search -forwards -regexp $balise  $debut end ] 
		if {$indice==""} { 	break
		} else {
		
  		${widtexte}lignes insert  "$indice lineend" " " ; #insère une espace après le numéro de ligne pour garder le gabarit sans modifier la taille de la police
		
		$widtexte tag add  T$i "$indice +6 char" "$indice lineend"
		${widtexte}lignes tag add  T$i "$indice lineend -1 chars" "$indice lineend" 
		}
		
		
		 set indice [$widtexte search -forwards -count longueur		-regexp $balise "$indice" end]
		 set debut "$indice + $longueur char"
		
		
		}	
		incr i
		}
		
}	

#<detagBalise>

proc JVSeditor::DetagBalises { widtexte } {

global taillePolice
global police 
variable couleur


$widtexte tag delete T1
$widtexte tag delete T2
$widtexte tag delete T3
$widtexte tag delete T4
$widtexte tag delete T5

${widtexte}lignes tag delete T1
${widtexte}lignes tag delete T2
${widtexte}lignes tag delete T3
${widtexte}lignes tag delete T4
${widtexte}lignes tag delete T5


	}
	
	
  
  
proc JVSeditor::RechercheBalises { widtexte } {
		variable ListeBalises
		set debut 1.0
		set  ListeBalises ""
		
		while 1 {
		 set indice [$widtexte search -forwards -regexp {//<\w+>}  $debut end ] ; # $indice est un numéro de ligne+numéro du caractère dans la ligne, un indice quoi!
		  if {$indice==""} { 	break}
		  
		  set indice [$widtexte search -forwards -count longueur		-regexp {//<\w+>} "$indice" end]
		  set debut "$indice + $longueur char"
		  append ListeBalises  "  $indice {[$widtexte get "$indice +6 char" "$indice lineend" ]} "
		}
		
		return $ListeBalises
		
	  }


proc JVSeditor::AfficheListeBalises {widtexte} {
		variable ListeBalises
		variable couleur
		global indexBalise1
		global indexBalise2
		
		destroy .topBalises ; #supprime la fenetre éventuellement ouverte précédemment
		
		# création d'une fenêtre pour les fonctions
		toplevel .topBalises
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topBalises +[expr ${largeurEcran}-350]+60
		text .topBalises.fenbalises -wrap word -bg turquoise   -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 12"	-yscrollcommand ".topBalises.sy set"  -relief groove  -cursor "hand1"
		scrollbar .topBalises.sy -orient vertical -command ".topBalises.fenbalises yview" -cursor hand2
		
		# appel de la procedure RechercherBalises
		JVSeditor::RechercheBalises $widtexte
		
		set max 0
		set compteur 0
		
		# écriture dans la fenêtre des fonction
		#ligne d'entête
		.topBalises.fenbalises insert end "Un clic sur une balise\n y positionne la fenêtre principale\n\n\n"
		
		set deb "début du script\n"
		.topBalises.fenbalises insert end $deb
		.topBalises.fenbalises tag add debZero 5.0 "5.0 lineend"
		.topBalises.fenbalises tag configure debZero  -underline 1
		
		# 1 clic et on voit le début du script dans la fenetre principale
		.topBalises.fenbalises tag bind debZero <1> "$widtexte see 1.0"
		
		# boucle 		pour afficher la liste des balises
		foreach {i el} $ListeBalises {
		  incr compteur
		  set l [string length $el]
		  if {$l>$max} {set max $l}
		  .topBalises.fenbalises insert end $el
		  .topBalises.fenbalises tag add $el "current linestart" "current lineend"
		  .topBalises.fenbalises tag configure $el -foreground black   -underline 1
		  
		  .topBalises.fenbalises tag bind $el <1> "$widtexte see $i	"	 ; # 1 clic et on voit la fonction dans la fenetre principale
		  .topBalises.fenbalises insert end \n ; # saut de ligne avant affichage des balises
		} ; #fin de la boucle d'affichage
		
		.topBalises.fenbalises insert 1.0	"Liste des $compteur balises \n\n"
		
		.topBalises.fenbalises configure -width [expr {$max+2} ]
		
		pack .topBalises.fenbalises 	-fill both -side right -expand true
		pack 	.topBalises.sy -fill y -side right
		
		bind .topBalises.fenbalises <3> "destroy .topBalises	"
	  }
	  
	  ################################################################################
	  # RECHERCHE ET AFFICHAGE  DES PROCEDURES
	  ################################################################################
#<PROCedures>  

proc JVSeditor::RechercheProcs { widtexte } {
		variable ListeProcs
		variable ListeProcsAlpha
		set debut 1.0
		set ListeProcs ""
		set ListeProcsAlpha ""
		
		  set ListeIntermediaire " merde " 
		
	  	if { [string match  "*function *" [$widtexte get 1.0 end] ] !=1 } {tk_messageBox -message " Il n'y a pas de fonctions dans votre script."  ; return}
		
		# partie propre à chrono
		while 1 {	
		
		  set indice [$widtexte search -forwards -regexp {^\s*function} $debut end] ; # $indice est un numéro de ligne+numéro du caractère dans la ligne, un indice quoi! 
		
		  if { $indice=="" } { break } 
		
		  set indice [ $widtexte search -forwards -count longueur -regexp {\s\w*\(.*\)} "$indice" end ] 						
		  set debut "$indice + $longueur char" 
		 append ListeProcs " [ $widtexte get $indice "$indice + $longueur char" ] $indice " 
		
		}
		
		
		# partie propre à alpha
		 set ListeProcsAlpha $ListeProcs
			  regsub -all {[\{\}]}	$ListeProcsAlpha  "µ" ListeProcsAlpha  ;#  traitement de la chaine pour que [trim \{\}] fonctionne (voir plus loin)
				
		#partie  pour proc alpha: on parcours la liste \
		avec deux variable pour concaténer le nom de la fonction et l'indice \
		afin d'en faire un élément d'une nouvelle liste \
		qu'on pourra alors trier selon l'ordre alphabétique,\
		puis dans afficherProcs() on rejoindra les éléments en une seule liste\
		parcourue par un foreach sur deux variables dont "ind" (pour indice) \
		permettant de se positionner dan sle texte au début de la fonction.		
				
		foreach {fonct ind} $ListeProcsAlpha {set element [concat $fonct $ind]  ; lappend listeFinale $element} 
		 set ListeProcsAlpha [lsort -dictionary $listeFinale]; 
		
		} ;#accolade de fin de proc ::rechercherProc
		  

proc JVSeditor::AfficheListeProcs { widtexte } {
		variable ListeProcs
		variable couleur
		global indexProc1
		global indexProc2
		
		
		
		destroy .topProcs ; #supprime la fenetre éventuellement ouverte précédemment
		
		# création d'une fenêtre pour les fonctions
		toplevel .topProcs
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topProcs +[expr ${largeurEcran}-350]+60
		text .topProcs.fenprocs -wrap word -bg SpringGreen  -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 12"	-yscrollcommand ".topProcs.sy set"  -relief groove  -cursor "hand1"
		scrollbar .topProcs.sy -orient vertical -command ".topProcs.fenprocs yview" -cursor hand2
		
		# appel de la procedure RechercherProcs
		JVSeditor::RechercheProcs $widtexte
		set max 0
		set compteur 0
		
		# écriture dans la fenêtre des fonction
		#ligne d'entête
		.topProcs.fenprocs insert end "Un clic sur une fonction\n y positionne \
			la fenêtre principale \n un double-clic ouvre une fenêtre \n avec n° de ligne.\n\n"
		set deb "début du script\n"
		.topProcs.fenprocs insert end $deb
		.topProcs.fenprocs tag add debZero 6.0 "6.0 lineend"
		.topProcs.fenprocs tag configure debZero -foreground red -underline 1
		# 1 clic et on voit le début du script dans la fenetre principale
		# double clic et le script s'affiche dans une nouvelle fenêtre avec n° de lignes
		.topProcs.fenprocs tag bind debZero <1> "$widtexte see 1.0"
		.topProcs.fenprocs tag bind debZero <Double-Button-1> " set indexProc1 1.0  ; set indexProc2 end ; JVSeditor::BodyProcsDebut $widtexte "
		
		foreach {el i} $ListeProcs {
		  incr compteur
		  set l [string length $el]
		  if {$l>$max} {set max $l}
		  .topProcs.fenprocs insert end $el
		  .topProcs.fenprocs tag add $el "current linestart" "current lineend"
		  .topProcs.fenprocs tag configure $el -foreground blue -underline 1
		  .topProcs.fenprocs tag bind $el <1> "$widtexte see $i	"
		  # 1 clic et on voit la fonction dans la fenetre principale
		  # double clic et le corps de la fonction s'affiche dans une nouvelle fenêtre avec n° de lignes
		  .topProcs.fenprocs tag bind $el <Double-Button-1> " set indexProc1 $i ; set indexProc2 end ; JVSeditor::BodyProcs $widtexte "
		  
		  .topProcs.fenprocs insert end \n
		}
		
		.topProcs.fenprocs insert 1.0	"Liste des $compteur fonctions \n\n"
		
		.topProcs.fenprocs configure -width [expr {$max+10} ]
		
		
		pack .topProcs.fenprocs 	-fill both -side right -expand true
		pack 	.topProcs.sy -fill y -side right
		
		
		bind .topProcs.fenprocs <3> "destroy .topProcs	"
	  }
	  
	  
	  
proc JVSeditor::AfficheListeProcsAlpha { widtexte } {
		variable ListeProcsAlpha
		variable couleur
		
		destroy .topProcsAlpha
		# création d'une fenêtre pour les fonctions alpha
		toplevel .topProcsAlpha
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topProcsAlpha +[expr ${largeurEcran}-400]+100
		text .topProcsAlpha.fenprocs -wrap word -bg GreenYellow   -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 12"	-yscrollcommand ".topProcsAlpha.sy set" -relief groove  -cursor "hand1"
		scrollbar .topProcsAlpha.sy -orient vertical -command ".topProcsAlpha.fenprocs yview" -cursor hand2
		JVSeditor::RechercheProcs $widtexte
		set max 0
		set compteur 0
		
		
		# écriture dans la fenêtre des fonction
		#ligne d'entête
		.topProcsAlpha.fenprocs insert end "Un clic sur une fonction\n y positionne \
			la fenêtre principale \n un double-clic ouvre une fenêtre \n avec n° de ligne.\n\n"
		set deb "début du script\n"
		.topProcsAlpha.fenprocs insert end $deb
		.topProcsAlpha.fenprocs tag add debZero 6.0 "6.0 lineend"
		.topProcsAlpha.fenprocs tag configure debZero -foreground red -underline 1
		# 1 clic et on voit le début du script dans la fenetre principale
		# double clic et le script s'affiche dans une nouvelle fenêtre avec n° de lignes
		.topProcsAlpha.fenprocs tag bind debZero <1> "$widtexte see 1.0"
		.topProcsAlpha.fenprocs tag bind debZero <Double-Button-1> " set indexProc1 1.0  ; set indexProc2 end ; JVSeditor::BodyProcsDebut $widtexte "
		
		#les occurences de fonctions (procs)
		 set ListeProcsAlpha [join $ListeProcsAlpha]
		
		foreach {el ind} $ListeProcsAlpha {
		  incr compteur
		  set l [string length $el]
		  if {$l>$max} {set max $l}
		  .topProcsAlpha.fenprocs insert end $el
		  .topProcsAlpha.fenprocs tag add $el "current linestart" "current lineend"
		  .topProcsAlpha.fenprocs tag configure $el -foreground blue -underline 1
		  .topProcsAlpha.fenprocs tag bind $el <1> "$widtexte see $ind	"
		  # 1 clic et on voit la fonction dans la fenetre principale
		  # double clic et le corps de la fonction s'affiche dans une nouvelle fenêtre avec n° de lignes
		  .topProcsAlpha.fenprocs tag bind $el <Double-Button-1> " set indexProc1 $ind ; set indexProc2 end ; JVSeditor::BodyProcs $widtexte "
		  .topProcsAlpha.fenprocs insert end \n
		}
		
		.topProcsAlpha.fenprocs insert 1.0	"Liste des $compteur fonctions \n\n"
		
		.topProcsAlpha.fenprocs configure -width [expr {$max+10} ] 
		
		
		pack .topProcsAlpha.fenprocs 	-fill both -side right -expand true
		pack  	.topProcsAlpha.sy -fill y -side right -expand true
		
		bind .topProcsAlpha.fenprocs <3> "destroy .topProcsAlpha	"
	  }
	  
	  #____________________________________________________________________________________
	  
	  
proc JVSeditor::BodyProcs {widtexte } {
		variable couleur
		global indexProc1
		global indexProc2
		
		destroy .topBodyProcs
		# création d'une fenêtre pour les fonctions
		toplevel .topBodyProcs
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topBodyProcs +[expr ${largeurEcran} - 400]+100
		text .topBodyProcs.fenprocs -wrap none -bg beige  -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 12"	-yscrollcommand ".topBodyProcs.sy set" -xscrollcommand ".topBodyProcs.sx set" -relief groove  -cursor "hand1"
		scrollbar .topBodyProcs.sy -orient vertical -command ".topBodyProcs.fenprocs yview" -cursor hand2
		scrollbar .topBodyProcs.sx -orient horizontal -command ".topBodyProcs.fenprocs xview" -cursor hand2
		
		set corpProc [$widtexte get $indexProc1 $indexProc2]
		.topBodyProcs.fenprocs tag configure tagProc -foreground red -background white
		#.topBodyProcs.fenprocs insert 1.0  "proc " tagProc
		.topBodyProcs.fenprocs insert 1.5 $corpProc
		
		.topBodyProcs.fenprocs tag  add  tagProc 1.0 "1.0 lineend"
		
		pack .topBodyProcs.sx -fill x
		
		pack .topBodyProcs.sy -fill y -side left
		pack .topBodyProcs.fenprocs -fill both -side left -expand 1
		
		
		bind .topBodyProcs.fenprocs <3> "destroy .topBodyProcs	"
		
		JVSeditor::NumeroterLignesFonction
		
	  }
	  
proc JVSeditor::BodyProcsDebut {widtexte } {
		variable couleur
		global indexProc1
		global indexProc2
		
		destroy .topBodyProcs
		# création d'une fenêtre pour les fonctions
		toplevel .topBodyProcs
		set largeurEcran [ winfo screenwidth . ]
		wm geometry .topBodyProcs +[expr ${largeurEcran} - 400]+100
		text .topBodyProcs.fenprocs -wrap none -bg beige  -fg $couleur(curseur)\
			-tabs {1c} -font "Helvetica 12"	-yscrollcommand ".topBodyProcs.sy set" -xscrollcommand ".topBodyProcs.sx set" -relief groove  -cursor "man"
		scrollbar .topBodyProcs.sy -orient vertical -command ".topBodyProcs.fenprocs yview" -cursor hand2
		scrollbar .topBodyProcs.sx -orient horizontal -command ".topBodyProcs.fenprocs xview" -cursor hand2
		
		set corpProc [$widtexte get $indexProc1 $indexProc2]
		.topBodyProcs.fenprocs insert 1.5 $corpProc
		
		.topBodyProcs.fenprocs tag configure tagProc -foreground red -background white
		.topBodyProcs.fenprocs insert 1.0 "DEBUT DU SCRIPT\n" tagProc
		.topBodyProcs.fenprocs insert end "\nFIN DU SCRIPT" tagProc
		
		pack .topBodyProcs.sx -fill x
		pack .topBodyProcs.sy -fill y -side left
		pack .topBodyProcs.fenprocs -fill both -side left
		
		
		bind .topBodyProcs.fenprocs <3> "destroy .topBodyProcs	"
		
		JVSeditor::NumeroterLignesFonction
		
	  }
	  
proc JVSeditor::NumeroterLignesFonction {} {
		set j 1 ;# lignes texte
		
		.topBodyProcs.fenprocs tag configure numéro -foreground red -background green
		
		set fenetre .topBodyProcs.fenprocs
		set nb [expr int([ $fenetre index end])-1]
		
			while {$j<$nb} {
		 	 set contenuLigne  [$fenetre get $j.0 "$j.0 lineend"]
		  	set finDeLigne [string index $contenuLigne end ]
				$fenetre insert "[expr $j + 1].0" "$j  " numéro
			  incr j
			}
		
		.topBodyProcs.fenprocs configure -state disabled
	  }
	  
	  
	
	  ################################################################################
	  #	# entrée pour choisir le mot pour recherche d'occurences
	  ################################################################################
#<Occurences>

proc JVSeditor::ChoisirMot {} {
		destroy .topMot 	; #ferme la fenêtre précédemment ouverte
		toplevel .topMot		; #ouvre la fenêtre de recherche
		label .topMot.label1 -text "rechercher : " -width 25 -font {-size 12}  -bg beige -justify left
		entry .topMot.entreMot  -textvariable motRecherche -font {-size 12} -bg ivory -justify left
		checkbutton .topMot.ch1 -text "Différencier Maj/Min" -variable majmin -onvalue 1 -offvalue 0 -font {-size 12} -bg beige -justify left
		checkbutton .topMot.ch2 -text "Expression Régulière" -variable expressRegul -onvalue 1 -offvalue 0 -font {-size 12} -bg beige -justify left
		checkbutton .topMot.ch3 -text "Dans texte caché	" -variable texteCache  -onvalue 1 -offvalue 0 -font {-size 12} -bg beige -justify left
		
		radiobutton .topMot.ch4 -text "Après curseur	" -variable wards  -value forwards -font {-size 12} -bg beige -justify left
		radiobutton .topMot.ch5 -text "Avant curseur	" -variable wards  -value backwards  -font {-size 12} -bg beige -justify left
		radiobutton .topMot.ch6 -text "Tout le texte	" -variable wards  -value 0  -font {-size 12} -bg beige -justify left
		radiobutton .topMot.ch7 -text "Texte sélectionné" -variable wards  -value selection  -font {-size 12} -bg beige -justify left
		
		button .topMot.ok -text "lancer la recherche" -bg beige -fg blue -font {-size 12} -bd 5 -relief raise \
			 -command { JVSeditor::AfficheListeOccurences $widtexte $motRecherche $wards $texteCache $majmin $expressRegul} -justify left
		grid .topMot.label1   -column 1 -row 1 -padx  3 -sticky ew
		grid .topMot.entreMot -column 1 -row 2 -padx 3 -sticky ew
		grid .topMot.ch1 -column 1 -row 3 -padx 3 -sticky ew
		grid .topMot.ch2 -column 1 -row 4 -padx 3 -sticky ew
		grid .topMot.ch3 -column 1 -row 5 -padx 3  -sticky ew
		grid .topMot.ch4 -column 1 -row 6 -padx 3  -sticky ew
		grid .topMot.ch5 -column 1 -row 7 -padx 3  -sticky ew
		grid .topMot.ch6 -column 1 -row 8 -padx 3  -sticky ew
		grid .topMot.ch7 -column 1 -row 9 -padx 3  -sticky ew
		grid .topMot.ok  -column 1 -row 10 -padx 3 -sticky ew
		
		bind .topMot <3> {destroy .topMot }
		
	  }
	  

proc JVSeditor::RechercherElement { widtexte element wards texteCache minMaj expressRegul } { 
 
		
		variable ListeOccurences
		
		 set indices [ $widtexte tag ranges sel ]
		  if { [llength $indices] == 0  } {
		  set debut 1.0
		  set fin end
		} else {
		  	set indices [ $widtexte tag ranges sel ]
		 	set debut [$widtexte index  [lindex $indices 0]]
			set fin [$widtexte index  [lindex $indices 1]]
			  }
		  
		
		$widtexte tag remove  surligner 1.0 end
		
	
		#différenciation des majuscules et des minuscules
		if {$minMaj == 1} {
		set  casse ""
		} else {
		 set casse "-nocase"
		}
		# recherche avec ou sans expression régulière
		set ListeOccurences ""
		if {$expressRegul==1} {
		  set com "-regexp $casse $element"
		} else {		  
		  set com $element
		}
		
		#recherche avec ou sans texte caché
		if {$texteCache == 1} {
			set masque "-elide"
		} else {
			set masque ""
		}
		
		#sens de la recherche
				
		switch $wards forwards {set debut [$widtexte index insert] ; set fin end  }
		switch $wards backwards {set fin [$widtexte index insert] ;set debut 1.0 }
		switch $wards 0 {set fin end  }
		switch $wards "" {set debut 1.0 ; set fin end  }
		switch $wards "selection" {set debut $debut ; set fin $fin  }
		
		# boucle de recherche enregistrant les indices d'occurences dans une liste "ListeOccurences"
		while 1 {
		  set lacom "$widtexte search $casse $masque -count longueur $com  \"$debut\" \"$fin\" "
		  set indice [eval $lacom]
		  if {$indice==""} { break }
		  lappend ListeOccurences $indice
		  set debut "$indice + $longueur char"
		}
		
	
	}
	
	
proc JVSeditor::AfficheListeOccurences { widtexte element wards texteCache majmin expressRegul} {
		variable ListeOccurences
		
		
		
		destroy .topMot.fenoccs
		destroy .topMot.occssy
		scrollbar .topMot.occssy -orient vertical -command ".topMot.fenoccs yview" -cursor "hand2"
		text  .topMot.fenoccs -wrap word -bd 6 -relief raised -bg lavender -fg black \
			-tabs {1c} -font "Helvetica 12"	-height 10 -yscrollcommand ".topMot.occssy set" -width 40 -cursor "hand1"
		
		
		
		JVSeditor::RechercherElement $widtexte $element $wards $texteCache $majmin $expressRegul
		
		grid .topMot.fenoccs  -row 1 -column 2 -rowspan 5
		grid .topMot.occssy -row 1 -column 3 -rowspan 5 -sticky ns
		
		# lancement de la boucle d'affichage dans la fenêtre crée à la ligne ci-dessus
		set compteur 0
		if {[llength $ListeOccurences]!=0} {
		  foreach el $ListeOccurences {
			
			set ligneOccurence "... ligne N° $el ème caractère..." ;# $el est un indice text (ex : 10.5 ) N°ligne.N°caractère
			
			$widtexte tag add surligner $el
			$widtexte tag configure surligner -background yellow
			
			.topMot.fenoccs insert end "Occurence $compteur : $ligneOccurence"
			.topMot.fenoccs tag add $compteur "current linestart" "current lineend"
			.topMot.fenoccs tag configure $compteur -foreground blue -underline 1
			.topMot.fenoccs tag bind $compteur <1> "$widtexte see $el ;destroy .topBulleOccurence "
			
			.topMot.fenoccs tag bind $compteur <Enter> ".topMot.fenoccs tag configure $compteur -background AntiqueWhite  -foreground blue -underline 1 ;JVSeditor::BulleOccurence $widtexte $el"
			.topMot.fenoccs tag bind $compteur <Leave> " .topMot.fenoccs tag configure $compteur -background  lavender  ; destroy .topBulleOccurence "
			
			.topMot.fenoccs insert end \n
			incr compteur
			
			
		  }
		}
		.topMot.fenoccs insert 1.0 "$compteur occurence(s) de \"$element\"\n\n"
		
		bind .topMot.fenoccs <3> {	destroy .topBulleOccurence  ;	destroy .topMot	; $widtexte tag remove "surligner" 1.0 end }
	  }
	  
proc JVSeditor::BulleOccurence { widtexte indice} {
		toplevel .topBulleOccurence
		text .topBulleOccurence.texte  -height 1 -bg White -fg tomato -relief raised -borderwidth 2
		
		wm overrideredirect .topBulleOccurence  1 ; # supprime la barre de titre
		set x [ winfo pointerx . ]
		set y [ winfo pointery . ]
		wm geometry .topBulleOccurence  +[expr $x + 10]+[expr $y - 10]
		
		set contenuLigneOccurence [ string trimleft [$widtexte get "$indice linestart" "$indice  lineend" ] " \t"]
		set contenuLigneOccurence [ string trimright $contenuLigneOccurence " " ]
		.topBulleOccurence.texte insert end $contenuLigneOccurence
		pack .topBulleOccurence.texte
		.topBulleOccurence.texte configure -width [string length $contenuLigneOccurence ]
		
	  }
	  
	  ###############################
	  #<remplacement>
	  
proc JVSeditor::Remplacer {widtexte } {
		destroy .topRemplace 	; #ferme la fenêtre précédemment ouverte
		toplevel .topRemplace		; #ouvre la fenêtre de recherche
		
		label .topRemplace.label1 -text "remplacer : "
		entry .topRemplace.entreMot  -textvariable motRecherche
		label .topRemplace.label2 -text "par : "
		entry .topRemplace.entreRemplacement  -textvariable aLaPlace
		button .topRemplace.ok -text "lancer la recherche-remplacement"  -command { JVSeditor::RemplacerMaintenant $widtexte $motRecherche $aLaPlace $majmin }
		checkbutton .topRemplace.ch1 -text "Différencier Maj/Min" -variable majmin -onvalue 1 -offvalue 0
		button .topRemplace.b2 -text "Remplacer tout" -command { JVSeditor::RemplacerTout $widtexte $motRecherche $aLaPlace $majmin }
		
		grid .topRemplace.label1   -column 1 -row 1 -padx  8
		grid .topRemplace.entreMot -column 1 -row 2 -padx 8
		grid .topRemplace.label2   -column 1 -row 3 -padx  8
		grid .topRemplace.entreRemplacement -column 1 -row 4 -padx 8
		grid .topRemplace.ok  -column 1 -row 5 -padx 8
		grid .topRemplace.ch1 -column 2 -row 1 -padx 8
		grid .topRemplace.b2 -column 2 -row 5 -padx 8
		
		bind .topRemplace <3> {destroy .topRemplace}
	  }
	  
proc JVSeditor::RemplacerMaintenant { widtexte motif remplacement mM } {
		if {$mM == 0} {
		  regexp  -indices -nocase -- $motif [$widtexte get 1.0 end ]  indicesRemplacement
		} else {
		  regexp  -indices -- $motif [$widtexte get 1.0 end ]  indicesRemplacement
		}
		
		if { [catch {
			$widtexte delete "1.0 + [expr [lindex  $indicesRemplacement 0] ] chars" \
			"1.0 + [expr [lindex $indicesRemplacement  1 ] +1] chars "
			$widtexte insert  "1.0 +  [lindex  $indicesRemplacement 0] chars"  $remplacement
			} ]  !=0
			}  { tk_messageBox -message "Pas d'autres occurences à remplacer par \"$remplacement\" " }
		
	  }
	  
proc JVSeditor::RemplacerTout { widtexte motif remplacement mM} {
		set i 0
		set tmM [ regexp  -indices -nocase -all -- $motif [$widtexte get 1.0 end ] ]
		set t [ regexp  -indices -all -- $motif [$widtexte get 1.0 end ] ]
		
		if {$mM == 0} {
		  while {$i <  $tmM } {
			regexp  -indices -nocase -- $motif [$widtexte get 1.0 end ]  indicesRemplacement
			$widtexte delete "1.0 + [expr [lindex  $indicesRemplacement 0] ] chars" \
				"1.0 + [expr [lindex $indicesRemplacement  1 ] +1] chars "
			$widtexte insert  "1.0 +  [lindex  $indicesRemplacement 0] chars"  $remplacement
			
			incr i
		  }
		} else {
		  while {$i < $t} {
			regexp  -indices  -- $motif [$widtexte get 1.0 end ]  indicesRemplacement
			$widtexte delete "1.0 + [expr [lindex  $indicesRemplacement 0] ] chars" "1.0 + [expr [lindex $indicesRemplacement  1 ] +1] chars "
			$widtexte insert  "1.0 +  [lindex  $indicesRemplacement 0] chars"  $remplacement
			
			incr i
		  }
		}
	  }
	  
proc JVSeditor::ChoixMarque {widtexte} { 
		global numeroMarque
		incr numeroMarque
		
		global marquesActuelles
		set  marquesActuelles {"" maMarqueTest}
		

		foreach i  [$widtexte dump -mark 1.0 end] {
		switch -glob --  $i anchor {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i insert {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i MK_* {set nomMarque [string trim $i  "MK_" ] ; lappend  marquesActuelles $nomMarque;}
		switch  -glob -- $i  *.* {	set nomMarque ""  ; lappend  marquesActuelles $nomMarque} 
		
		}
		
		set marquesActuelles [lsort -unique $marquesActuelles ] 
	

		# ouverture d'une boite d'entrée
		destroy .entreeMarque 
		toplevel .entreeMarque 
		frame .entreeMarque.f
		pack .entreeMarque.f
		label .entreeMarque.f.etiquette -text "Entrez un nom pour la nouvelle marque ($numeroMarque ème) : "
		spinbox .entreeMarque.f.nomMarque -textvariable nouvelleMarque -values $marquesActuelles
		label .entreeMarque.f.etiquetteGravitation -text gravity
		radiobutton 	.entreeMarque.f.gravitationG -text gauche -variable gravitation -value left
		radiobutton 	.entreeMarque.f.gravitationD -text droite -variable gravitation -value right
		button .entreeMarque.f.ok -text "Valider" -command {	if { $nouvelleMarque == ""} { set nouvelleMarque "marque$numeroMarque" }
												set nomMarque MK_$nouvelleMarque ; 
												JVSeditor::Marquer $widtexte $nomMarque $gravitation;
												set nouvelleMarque "" }
		pack .entreeMarque.f.etiquette .entreeMarque.f.nomMarque  -side top
		pack .entreeMarque.f.etiquetteGravitation  .entreeMarque.f.gravitationG \
			 .entreeMarque.f.gravitationD  .entreeMarque.f.ok -side top -expand  true -fill x

		bind .entreeMarque.f <3> { destroy .entreeMarque }
		bind .entreeMarque.f.etiquette <3> { destroy .entreeMarque }
		bind .entreeMarque.f.nomMarque <3> { destroy .entreeMarque }
		bind .entreeMarque.f.ok <3> { destroy .entreeMarque }
		}
	  #####################	
	#<MARQUES>
	  
proc JVSeditor::ChoixMarque {widtexte} { 
		global numeroMarque
		incr numeroMarque
		
		global marquesActuelles
		set  marquesActuelles {"" maMarqueTest}
		

		foreach i  [$widtexte dump -mark 1.0 end] {
		switch -glob --  $i anchor {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i insert {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i MK_* {set nomMarque [string trim $i  "MK_" ] ; lappend  marquesActuelles $nomMarque;}
		switch  -glob -- $i  *.* {	set nomMarque ""  ; lappend  marquesActuelles $nomMarque} 
		
		}
		
		set marquesActuelles [lsort -unique $marquesActuelles ] 
	

		# ouverture d'une boite d'entrée
		destroy .entreeMarque 
		toplevel .entreeMarque 
		frame .entreeMarque.f
		pack .entreeMarque.f
		label .entreeMarque.f.etiquette -text "Entrez un nom pour la nouvelle marque ($numeroMarque ème) : "
		spinbox .entreeMarque.f.nomMarque -textvariable nouvelleMarque -values $marquesActuelles
		label .entreeMarque.f.etiquetteGravitation -text gravity
		radiobutton 	.entreeMarque.f.gravitationG -text gauche -variable gravitation -value left
		radiobutton 	.entreeMarque.f.gravitationD -text droite -variable gravitation -value right
		button .entreeMarque.f.ok -text "Valider" -command {	if { $nouvelleMarque == ""} { set nouvelleMarque "marque$numeroMarque" }
												set nomMarque MK_$nouvelleMarque ; 
												JVSeditor::Marquer $widtexte $nomMarque $gravitation;
												set nouvelleMarque "" }
		pack .entreeMarque.f.etiquette .entreeMarque.f.nomMarque  -side top
		pack .entreeMarque.f.etiquetteGravitation  .entreeMarque.f.gravitationG \
			 .entreeMarque.f.gravitationD  .entreeMarque.f.ok -side top -expand  true -fill x

		bind .entreeMarque.f <3> { destroy .entreeMarque }
		bind .entreeMarque.f.etiquette <3> { destroy .entreeMarque }
		bind .entreeMarque.f.nomMarque <3> { destroy .entreeMarque }
		bind .entreeMarque.f.ok <3> { destroy .entreeMarque }
		}
		
proc JVSeditor::Marquer {widtexte nouvelleMarque gravitation} {
	
		$widtexte mark set $nouvelleMarque insert 
		$widtexte mark gravity  $nouvelleMarque  $gravitation
		
		JVSeditor::MenuMarques $widtexte 
	}
		
proc JVSeditor::MenuMarques {widtexte } {		
	global marquesActuelles
	set marquesActuelles {"" maMarqueTest}

		set nomMarque ""
	# on met à jour le menu des marques
		.menubar.mMarques add radiobutton -label n2				
		.menubar.mMarques delete 4 end
							
		foreach i  [$widtexte dump -mark 1.0 end] {
		switch -glob --  $i anchor {set nomMarque "" }
		switch -glob --  $i insert {set nomMarque "" }
		switch -glob --  $i MK_* {set nomMarque $i  }
		switch  -glob -- $i  *.* {	 if { [lindex $nomMarque] >0 } {
						.menubar.mMarques add radiobutton -label "$nomMarque $i"\
						-command "JVSeditor::InfoMarques $widtexte $i"
						set nomMarque ""
						}

					}
		}
		destroy .entreeMarque 
	}
	
	
proc JVSeditor::SupprimerMarque {widtexte } {		
	
		global marquesActuelles
		set  marquesActuelles {"" maMarqueTest}
		

		foreach i  [$widtexte dump -mark 1.0 end] {
		switch -glob --  $i anchor {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i insert {set nomMarque "" ;lappend  marquesActuelles $nomMarque}
		switch -glob --  $i MK_* {set nomMarque [string trim $i  "MK_" ] ; lappend  marquesActuelles $nomMarque;}
		switch  -glob -- $i  *.* {	set nomMarque ""  ; lappend  marquesActuelles $nomMarque} 
		
		}
		
		set marquesActuelles [lsort -unique $marquesActuelles ] 
	

		# ouverture d'une boite d'entrée
		destroy .supprimeMarque 
		toplevel .supprimeMarque
		frame .supprimeMarque.f
		pack .supprimeMarque.f
		label .supprimeMarque.f.etiquette -text "Supprimer la marque : "
		spinbox .supprimeMarque.f.nomMarque -textvariable texteMarque -values $marquesActuelles
			
		button .supprimeMarque.f.ok -text "Valider" -command {		set nomMarque MK_$texteMarque ; 
												$widtexte mark unset  $nomMarque
												JVSeditor::MenuMarques $widtexte 
												destroy .supprimeMarque 
												}
		pack .supprimeMarque.f.etiquette .supprimeMarque.f.nomMarque .supprimeMarque.f.ok -side left
		
		bind .supprimeMarque.f <3> { destroy .supprimeMarque  }
		bind .supprimeMarque.f.etiquette <3> { destroy .supprimeMarque }
		bind .supprimeMarque.f.nomMarque <3> { destroy .supprimeMarque }
		bind .supprimeMarque.f.ok <3> { destroy .supprimeMarque }
	

}
		  
		  
proc JVSeditor::InfoMarques {widtexte numMarque} {
		global choixMarque
		if { $choixMarque == ""} { 
			tk_messageBox -message "Vous allez avoir un message d'erreur\ncar il faut faire d'abord un choix dans les options de recherche de marques\n" 
			} 
		destroy .marques
		toplevel .marques
		text .marques.fenMarques -bg "sea green" -fg yellow
		pack .marques.fenMarques
		.marques.fenMarques insert end  [$widtexte dump $choixMarque $numMarque end] 
		bind .marques.fenMarques <3> {destroy .marques}
	  }
	  
	  
	  ####################
	  #<commentarisation>
	  
proc JVSeditor::PermuteCommentaireSpecial {widtexte } {
		variable permute
		set indices [ $widtexte tag ranges sel ]
		if { [llength $indices] == 0 } {tk_messageBox -type ok -message "Il n'y a pas de bloc sélectionné" -title "Commentage ..." -icon error ; return }
		set bloc [$widtexte get [lindex $indices 0] [lindex $indices 1]]
		puts "indices  : $indices \n"
		# $indices est une liste d'indices de texte de la forme entier/point/entier;
		#donc [lindex $indices 0] est une chaine entier/point/entier que l'on peut disjoindre selon le "point"
		#en supprimant  elements sauf le premier, on obtient un entier
		set splitDebutBloc [split [lindex $indices 0] .]
		set ligneDebutBloc [lindex $splitDebutBloc 0]
		puts "ligne debut : $ligneDebutBloc \n"
		set splitFinBloc [split [lindex $indices 1] .]
		set ligneFinBloc [lindex $splitFinBloc 0]
		puts "ligne fin bloc : $ligneFinBloc \n"
		set rg [regexp {^//£} $bloc]
		if {$rg==0 } {
		  set permute 0
		} else {set permute 1
		}
		JVSeditor::CommenterSelectionSpeciale $widtexte $permute $ligneDebutBloc $ligneFinBloc
	  }
	  
proc JVSeditor::CommenterSelection {widtexte bit } {
		
		set indices [ $widtexte tag ranges sel ]
		if { [llength $indices] == 0 } {tk_messageBox -type ok -message "Il n'y a pas de bloc sélectionné" -title "Commentage ..." -icon error ; return }
		set bloc [$widtexte get [lindex $indices 0] [lindex $indices 1]]
		puts "indices  : $indices \n"
		# $indices est une liste d'indices de texte de la forme entier/point/entier;
		#donc [lindex $indices 0] est une chaine entier/point/entier que l'on peut disjoindre selon le "point"
		#en supprimant  elements sauf le premier, on obtient un entier
		set splitDebutBloc [split [lindex $indices 0] .]
		set ligneDebutBloc [lindex $splitDebutBloc 0]
		puts "ligne debut : $ligneDebutBloc \n"
		set splitFinBloc [split [lindex $indices 1] .]
		set ligneFinBloc [lindex $splitFinBloc 0]
		puts "ligne fin bloc : $ligneFinBloc \n"
		
		
		set i $ligneDebutBloc
		
		if {$bit != 0} {
		  while {$i <= $ligneFinBloc} {
			$widtexte insert $i.0 "//"
			incr i
		  }
		} else {
		  while {$i <= $ligneFinBloc} {
			set texteLigne [$widtexte get $i.0 "$i.0 lineend"]
			set trimTexteLigne [string trimleft $texteLigne ] ;		# on supprime les espaces superflus en début de ligne pour tester la présence des controbliques 
			set rg [regexp {^//} $trimTexteLigne ]
			if  {$rg != 0} {
			  $widtexte delete $i.0 "$i.0 lineend"
			  $widtexte insert $i.0 $trimTexteLigne
			  $widtexte delete $i.0 
			$widtexte delete $i.0
			}
			incr i
		  }
		}
		
	  }
	  
	  
proc JVSeditor::CommenterSelectionSpeciale {widtexte bit ligneDebut ligneFin} {
		set i $ligneDebut
		
		# si le bloc n'est pas bicontrobliqué on insère un commentaire spécial "//£" en début de chaque ligne
		if {$bit == 0} {
		  while {$i <= $ligneFin} {
			$widtexte insert $i.0 "//£ " ;# une espace est insérée après le dièse et le sterling
			incr i
		  }
		} else {
		  set texteLigne [$widtexte get $ligneDebut.0 "$ligneDebut.0 lineend"]
		  set rg [regexp {^//£} $texteLigne ]
		  if  {$rg != 0} {
			while {$i <= $ligneFin} {
			  # set ligneSpeciale [string trimright [$widtexte get $i.0 "$i.0 lineend" ] "\{"]
			  set ligneSpeciale [$widtexte get $i.0 $i.3 ]
			  if {[string compare $ligneSpeciale  //£ ] != 0} {
				tk_messageBox -message "Une ligne ne fait pas partie du bloc spécial" -icon warning \
					-type ok -title "BLOC SPECIAL"
				return
			  } else {
				$widtexte delete $i.0 $i.4 ;# supprime //£ plus l'espace insérée après
				incr i
			  }
			}
		  }
		}
		
	  }
	  
	  ####################################################
	  
proc JVSeditor::NbLignes { widtexte widetiquette } {
		set nb [expr int([$widtexte index end])-1]
		set mot lignes
		if {$nb==1} {set mot seule\ ligne}
		set cc "curseur : "
		set coords $cc[$widtexte index insert]
		
		$widetiquette configure -text "$coords\t$nb $mot" -fg blue
	  }
	  
proc JVSeditor::ChoisirLigne {widtexte} {
	global widpage	
	set widpage [ lindex [ split $widtexte .] 2]

	
	set nomGlob "lignesChoisies$widpage"
	global $nomGlob

	
		destroy .topLigne$widpage
		toplevel .topLigne$widpage -background turquoise 
		bind .topLigne$widpage <3> {destroy .topLigne$widpage}
		label .topLigne$widpage.etiquetteNumeroLigne -text "entrez un numerode ligne et valider" -font {size 12}
		pack .topLigne$widpage.etiquetteNumeroLigne
		spinbox .topLigne$widpage.memoireNumeroLigne -textvariable numeroLigne -values [set lignesChoisies$widpage] -font {size 12}
		pack .topLigne$widpage.memoireNumeroLigne -side left
		focus .topLigne$widpage.memoireNumeroLigne
		button .topLigne$widpage.valider -text "Envoi" -command  {;lappend  lignesChoisies$widpage  $numeroLigne ;  lsort -unique  lignesChoisies$widpage ; destroy  .topLigne$widpage ;JVSeditor::AllerLigne $widtexte  $numeroLigne ;} -font  {size 12}
		pack .topLigne$widpage.valider
		
		
	  }
	  
		  
proc JVSeditor::AllerLigne {widtexte ligne} {
variable lignesChoisies


		set nb [expr int([$widtexte index end])-1]
		if {$ligne > $nb} {
		  tk_messageBox -message "NOMBRE TROP ELEVE : \n vérifiez le nombre de ligne de votre texte \n dans la barre d'état à droite" \
			  -icon warning -type ok
		} else {
		  $widtexte see $ligne.0
		  $widtexte tag remove "tagLigne" 1.0 end
		  $widtexte tag configure "tagLigne" -background GreenYellow
		  $widtexte tag add "tagLigne" $ligne.0  "$ligne.0 lineend"
		}
		$widtexte tag bind "tagLigne" <KeyPress> {$widtexte tag remove "tagLigne" 1.0 end}

	  }
	  
	
proc JVSeditor::Tampon {widtexte} {
		variable indexTampon
		set selection [$widtexte tag ranges sel]
		if {[llength $selection ]==0} {return}
		set index1 [lindex $selection 0]
		set index2 [lindex $selection 1]
		set mot [$widtexte get $index1 $index2]
		
		.menubar.mTampon add radio	-label $mot	 -variable motTampon -value $mot 	-background turquoise  -activebackground yellow -activeforeground black\
			-command {$widtexte insert insert "$motTampon "}
		incr indexTampon
		
	  }
	

proc JVSeditor::Surlignage {widtexte }  {
		global mesMots
		global couleurMesMots 
		
				#début de la zone à coloriser
			variable debut ;
			set debut 1.0
							
		$widtexte tag remove tagSurlignage $debut end
		
		foreach motColoriable $mesMots {
		set finTag 1.0
		set debut 1.0
		set texte [$widtexte get $debut end]
		
 			while { [regexp  $motColoriable  $texte ] != 0 } {
			set indexTag [$widtexte search  -exact -forward -count longueurMotColoriable -- $motColoriable $debut ]		
			set finTag "$indexTag +$longueurMotColoriable  chars " 		
			set longueurPlusUn [expr {$longueurMotColoriable+1}]
			$widtexte tag add tagSurlignage $indexTag $finTag
			set debut "$indexTag +$longueurPlusUn chars"
			set texte [$widtexte get $debut end]
			}
		}
		
		  $widtexte tag configure tagSurlignage -foreground $couleurMesMots
}
	
# création de la boite de choix des mots à surligner 	
proc JVSeditor::ChoixSurlignage {widtexte}  {
		global mesMots
		global couleurMesMots 
		
		destroy .classSurligneText 
		toplevel .classSurligneText -background turquoise 
		wm title .classSurligneText "Mes mots colorisés"
		frame .classSurligneText.f
		pack .classSurligneText.f
		

	# entrer des mots
		label .classSurligneText.f.labelMots -text "Entrer les mots à surcolorier"  -background turquoise
		spinbox .classSurligneText.f.spinMots -textvariable mesMotsSurlignage -values $mesMots -background white 
		button .classSurligneText.f.boutonColor -text "Choix Couleur" -background $couleurMesMots -activebackground ivory\
						-command { $widtexte configure -cursor watch
								 set couleurMesMots [ tk_chooseColor ] ;
								 .classSurligneText.f.boutonColor configure  -background $couleurMesMots
								$widtexte configure -cursor arrow
								} 
		button .classSurligneText.f.boutonMots -text "Valider chaque mot nouveau" -background turquoise  -activebackground ivory\
			-command {
					set mesMots [lsort -unique [ lappend mesMots $mesMotsSurlignage ] ]
					.classSurligneText.f.spinMots configure -values $mesMots
					 }
					
		button .classSurligneText.f.boutonOK -text "Surcolorier les mots" -background turquoise  -activebackground ivory\
		 -command {
				$widtexte configure -cursor watch
				
				JVSeditor::Surlignage $widtexte 
				
				$widtexte configure -cursor arrow
				destroy .classSurligneText
				}
				
	# supprimer des mots
		button .classSurligneText.f.boutonMotsSupprim -text "Valider pour supprimer le mot affiché" -background turquoise  -activebackground ivory\
		 -command {	
				$widtexte tag delete MaClasseMots
				regsub $mesMotsSurlignage $mesMots "" mesMots; 
				set mesMots [lsort -unique $mesMots ] ;			
				.classSurligneText.f.spinMots configure -values $mesMots
				 }
	# désurligner les mots coloriés			
	button .classSurligneText.f.boutonDecolorier -text "Décolorier les mots" -background turquoise  -activebackground ivory\
		 -command	{ 	$widtexte tag remove tagSurlignage 1.0 end	}
		
		pack  .classSurligneText.f.boutonColor .classSurligneText.f.labelMots  .classSurligneText.f.spinMots .classSurligneText.f.boutonMots \
			  .classSurligneText.f.boutonMotsSupprim  .classSurligneText.f.boutonOK .classSurligneText.f.boutonDecolorier -side top -expand true -fill both
		
		bind  .classSurligneText.f <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.boutonColor <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.labelMots <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.spinMots <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.boutonMots <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.boutonMotsSupprim <3> {destroy .classSurligneText} 
		bind  .classSurligneText.f.boutonOK <3> {destroy .classSurligneText} 
			

}
	
	
	
proc JVSeditor::EscapePermute {widtexte} {

	set dernier [$widtexte get "insert -1 char"]
	$widtexte delete [$widtexte index "insert -1 char"]
	$widtexte insert [$widtexte index "insert -1 char"] $dernier

}

proc JVSeditor::CompteAccollades {widtexte} {

$widtexte tag remove accolladeDepart 0.1 end
$widtexte tag remove accolladeArrivee 0.1 end
	$widtexte tag configure accolladeDepart -background green
	$widtexte tag configure accolladeArrivee -background orange
	
	$widtexte tag add accolladeDepart "insert -1 char"
	set indiceDepart [$widtexte index "insert -1 char"]
	set signeDepart [$widtexte get "insert -1 char"]
	
	switch $signeDepart {
		
		\{ { 
			# accollade ouvrante 
			set signeIntermediaire  a
			set indiceArrivee [$widtexte search -forward \}  insert]
			set i insert
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre accolade ouvrante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search \{ $i "$indiceArrivee "] 
				if { $signeIntermediaire  != "" } {
					# on recherche une autre accolade fermante plus loin
					set i "$signeIntermediaire  +1 char"
					set j "$indiceArrivee +1 char "
					 set indiceArrivee [$widtexte search -forward \}  $j end] 
					}
			} 
				
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque une accollade fermante à votre script" 
			} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
				}
		  }
		}
		
	switch $signeDepart {
		
			\[ { 
			# crochet ouvrant 
			set signeIntermediaire  a
			set indiceArrivee [$widtexte search -forward \]  insert]
			set i insert
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre accolade ouvrante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search \[ $i "$indiceArrivee "] 
				if { $signeIntermediaire  != "" } {
					# on recherche une autre accolade fermante plus loin
					set i "$signeIntermediaire  +1 char"
					set j "$indiceArrivee +1 char "
					 set indiceArrivee [$widtexte search -forward \]  $j end] 
					}
			} 
				
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque un crochet  fermant à votre script" 
			} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
				}
			}
			}
			

			
	switch $signeDepart {
				
		\} { 
			# accollade fermante 
			 set signeIntermediaire  a
			set indiceArrivee [$widtexte search -backward \{   "insert " ]
			set i "insert -1 char" 
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre accolade fermante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search -backward \} $i  "$indiceArrivee "  ] 
				if { $signeIntermediaire  != "" } {
					# on recherche une autre accolade fermante plus haut 
					set i "$signeIntermediaire "
					set j "$indiceArrivee "
					set indiceArrivee [$widtexte search -backward  \{  $j  1.0] 
				}
			} 
			
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque une accollade ouvrante à votre script" 
			} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
				}
			}
		}
			
	switch $signeDepart {	
		
		\] { 
			#crochet fermant
			 set signeIntermediaire  a
			set indiceArrivee [$widtexte search -backward \]   "insert " ]
			set i "insert -1 char" 
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre accolade fermante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search -backward \] $i  "$indiceArrivee "  ] 
					if { $signeIntermediaire  != "" } {
					# on recherche une autre accolade fermante plus haut 
					set i "$signeIntermediaire "
					set j "$indiceArrivee  "
					set indiceArrivee [$widtexte search -backward  \[  $j  1.0] 
						
											}
										} 
				
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque un crochet fermant à votre script" 
								} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
									}
		}
			

		} 
		
		#routine pour les parenthèses 
		
			switch $signeDepart {
		
			\( { # parenthèse ouvrante 
			set signeIntermediaire  a
			set indiceArrivee [$widtexte search -forward \(  insert]
			set i insert
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre accolade ouvrante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search \( $i "$indiceArrivee "] 
				if { $signeIntermediaire  != "" } {
					# on recherche une autre accolade fermante plus loin
					set i "$signeIntermediaire  +1 char"
					set j "$indiceArrivee +1 char "
					 set indiceArrivee [$widtexte search -forward \)  $j end] 
					}
			} 
				
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque une parenthèse fermante à votre script" 
			} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
				}
			}
			}


	switch $signeDepart {
				
		\) { # parenthèse fermante 
			 set signeIntermediaire  a
			set indiceArrivee [$widtexte search -backward \(   "insert " ]
			set i "insert -1 char" 
			
			while { $signeIntermediaire != ""  }  { 
				# recherche d'une autre parenthèse fermante entre 
				if  { $indiceArrivee == "" } { break }
				 set signeIntermediaire  [$widtexte search -backward \) $i  "$indiceArrivee "  ] 
				if { $signeIntermediaire  != "" } {
					# on recherche une autre parenthèse fermante plus haut 
					set i "$signeIntermediaire "
					set j "$indiceArrivee "
					set indiceArrivee [$widtexte search -backward  \( $j  1.0] 
				}
			} 
			
			if  { $indiceArrivee == "" } {
			tk_messageBox -message "Il manque parenthèse fermante à votre script" 
			} else {		
			 $widtexte tag add accolladeArrivee $indiceArrivee 
			$widtexte see $indiceArrivee
				}
			}
			}


}
  
proc JVSeditor::EnregConfig { } {
		global Chemin
		variable couleur
		global police 
		global taillePolice
		global navigateur
				
		set fichier [open [file join $Chemin(rel) JSeditor.rc] w]
		puts $fichier "# fichier de configuration de JSeditor"
		puts $fichier "#################################################"
		foreach cle [array names couleur] {
		  puts $fichier "# Couleur $cle\nset couleur($cle) $couleur($cle)"
		}
		puts $fichier "# Taille police \nset taillePolice $taillePolice"
		puts $fichier "#  police \nset police [list $police]"
		puts $fichier "#  navigateur \n set navigateur $navigateur"
		close $fichier
	  }
	  
	  
proc JVSeditor::LectureConfig { } {
		global Chemin
		variable couleur
 		global police
 		global taillePolice
		
		set fichier [open [file join $Chemin(rel) JSeditor.rc] r]
		while {![eof $fichier] } {
		  eval [gets $fichier]
		}
		close $fichier
	  } 
	
	  
	  
	  #<INTERFACE>
#---------------------------------------------------------------------------------
# fonctions de base  appelées en donnant les paramètres menuJSE , la liste de mots, et la longueur de la colonne menu
# utilisée (tardivement) pour les menu methodes. Le script est plus compact 
# mais les fonctions sont les même que pour les autres menus.

proc JVSeditor::boucleBoutons { menuJSE mots breakValeur} {
variable couleur
				
		 set i 0
		foreach élément $mots {
		  if { ($i==$breakValeur) || ($i== ($breakValeur*2)) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $menuJSE add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
}

		  	
proc JVSeditor::boucleCascades {menuJSE mots breakValeur} {

 set i 0
		foreach élément $mots {
		  if { ($i==$breakValeur) || ($i== ($breakValeur*2)) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $menuJSE add cascade -label $mot -menu $menuJSE.$mot
		menu $menuJSE.$mot
		
		  incr i
		}
}

# exemples d'appel de la fonction
	# JVSeditor::boucleBoutons $Methodes $mots 15
	# ou
	# JVSeditor::boucleCascade $Methodes $mots 12 
#---------------------------------------------------------------------------------		  
	
proc JVSeditor::Gui {} {
		global tcl_version tcl_platform
		global Chemin
		variable ausujetdeDC
		variable ausujetdeJLD
		variable ausujetdeDM
		variable ausujetdeMSDZ 
		variable ausujetdeJN  
		variable ausujetdeSUCF
		variable application
		variable version
		variable fichier
		variable couleur
		variable ListeRecents
		variable MotRecherche
		variable motscles
		global choixMarque
		global numeroPage
		global widtexte
		global police
		global taillePolice
		
		wm title . "$application version : $version"
		
		
		# zone texte
		
		frame .ftext 
		pack   .ftext -padx 2 -pady 2   -expand true -fill both
		
		#création d'une page neutre
		text  .ftext.0   -background #d9d9d9     
		
		# incrementation de la variable globale "numeroPage" pour fixer sa valeur à 1
		incr numeroPage
		
		if {$tcl_version>=8.4} {
		  .ftext.0 configure -undo 1 -autoseparators 1
		}
		scrollbar .ftext.sx0 -orient horizontal -command {.ftext.0 xview} 
		scrollbar .ftext.sy0 -orient vertical -command {.ftext.0 yview } 
		
		pack .ftext.sy0 -fill y -side right
		pack  .ftext.0 	-fill both	-expand true
		pack .ftext.sx0 -fill x -side top
		
	#<page_defaut>	
		.ftext.0 configure -state disable 
		set widtexte .ftext.0
		
	
		#<BARRE_MENUS_gavarnie>
		menu .menubar -activebackground LemonChiffon 
		. config -menu .menubar 
		
		option add *Menu.activeBackground gray 
		
		
  		foreach m { Fichier Editer Outils Pages Prefs Aide ***** Objets Attributs Methodes Evenements Color Tampon } {
			set $m [ menu .menubar.m$m -tearoff 1]
			  .menubar add cascade -label $m -menu .menubar.m$m
		}
		
		################################################################################
		# # barre des icones
		################################################################################
		
		
		
		frame .ficones -relief groove -bd 3  
		option add *Button.activeBackground LemonChiffon ; # couleur par défaut des boutons survolés : LemonChiffon 
		pack .ficones -fill both  -before .ftext 
		
	#<iconesStandards>
	
		#icone nouveau
		set imgNouveau [image create photo -file [file join $Chemin(rel) images nouveau.gif]]
		button .ficones.nouveau -image $imgNouveau -relief flat -command {JVSeditor::Nouveau}   
		pack .ficones.nouveau -side left
		bind .ficones.nouveau <Enter> {;after 50  ; .fetat.message configure -text ">> Ouvrir un nouveau fichier ..."}
		bind .ficones.nouveau <Leave> { ; .fetat.message configure -text ""}
		
		#icone ouvrir
		set imgOuvrir [image create photo -file [file join $Chemin(rel) images open.gif]]
		button .ficones.ouvrir -image $imgOuvrir -relief flat -command {JVSeditor::Ouvrir }
		pack .ficones.ouvrir -side left
		bind .ficones.ouvrir <Enter> { ;after 50 ; ; .fetat.message configure -text ">> Ouvrir un fichier ..."}
		bind .ficones.ouvrir <Leave> { ; .fetat.message configure -text ""}
		
		#icone sauver
		set imgSauver [image create photo -file [file join $Chemin(rel) images save.gif]]
		button .ficones.sauver -image $imgSauver -relief flat -command {JVSeditor::Sauvegarder $widtexte 0}
		pack .ficones.sauver -side left
		bind .ficones.sauver <Enter> {; after 50  ; .fetat.message configure -text ">> Sauvegarder le fichier en cours ..."}
		bind .ficones.sauver <Leave> {; .fetat.message configure -text ""}
		
		#icone sauverSous
		set imgSauverSous [image create photo -file [file join $Chemin(rel) images toSave.gif]]
		button .ficones.sauverSous -image $imgSauverSous -relief flat -command {JVSeditor::Sauvegarder $widtexte 1}
		pack .ficones.sauverSous -side left
		bind .ficones.sauverSous <Enter> { ;after 50 ; .fetat.message configure -text ">> Sauvegarder le fichier sous un nouveau nom ..."}
		bind .ficones.sauverSous <Leave> { ; .fetat.message configure -text ""}
		
		#icone Fermer
		set imgFermer [image create photo -file [file join $Chemin(rel) images remove.gif]]
		button .ficones.fermer -image $imgFermer -relief flat -command {JVSeditor::Fermer $widtexte}
		pack .ficones.fermer -side left
		bind .ficones.fermer <Enter> { ;after 50 ; .fetat.message configure -text ">> Ferme le fichier en cours..."}
		bind .ficones.fermer <Leave> { ;.fetat.message configure -text ""}
		
		#icone Imprimer
		set imgImprimer [image create photo -file [file join $Chemin(rel) images print.gif]]
		button .ficones.imprimer -image $imgImprimer -relief flat -command {JVSeditor::Imprimer $widtexte}
		pack .ficones.imprimer -side left
		bind .ficones.imprimer <Enter> { ;after 50; .fetat.message configure -text ">> Imprime le texte en cours..."}
		bind .ficones.imprimer <Leave> {  ;.fetat.message configure -text ""}
		
		#icone Separateur
		label .ficones.separateur1 -relief groove -bd 2
		pack .ficones.separateur1 -side left
		
		#icone defaire
		set imgDefaire [image create photo -file [file join $Chemin(rel) images undo.gif]]
		button .ficones.defaire -image $imgDefaire -relief flat -command {JVSeditor::Defaire $widtexte}
		pack .ficones.defaire -side left
		bind .ficones.defaire <Enter> {.ficones.defaire configure -background LightBlue  ;after 50  ; .fetat.message configure -text ">> Annule la dernière action (undo)"}
		bind .ficones.defaire <Leave> {.ficones.defaire configure -background gray  ; .fetat.message configure -text ""}
		
		#icone refaire
		set imgRefaire [image create photo -file [file join $Chemin(rel) images redo.gif]]
		button .ficones.refaire -image $imgRefaire -relief flat -command {JVSeditor::Refaire $widtexte}
		pack .ficones.refaire -side left
		bind .ficones.refaire <Enter> {.ficones.refaire configure -background LightBlue  ;after 50  ; .fetat.message configure -text ">> Refait la dernière action annulée(redo)"}
		bind .ficones.refaire <Leave> { .ficones.refaire configure -background gray  ;.fetat.message configure -text ""}
		
		#icone Separateur
		label .ficones.separateur2 -relief groove -bd 2
		pack .ficones.separateur2 -side left
		
		#icone commenter
		set imgCommenter [image create photo -file [file join $Chemin(rel) images commenter.gif]]
		button .ficones.commenter -image $imgCommenter -relief flat -command {JVSeditor::CommenterSelection $widtexte 1}
		pack .ficones.commenter -side left
		bind .ficones.commenter <Enter> {after 50 ; .fetat.message configure -text ">> \"Commenter\" la sélection" }
		bind .ficones.commenter <Leave> { .fetat.message configure -text "" }
		
		#icone décommenter
		set imgDecommenter [image create photo -file [file join $Chemin(rel) images decommenter.gif]]
		button .ficones.decommenter -image $imgDecommenter -relief flat -command {JVSeditor::CommenterSelection $widtexte 0}
		pack .ficones.decommenter -side left
		bind .ficones.decommenter <Enter> {after 50  ; .fetat.message configure -text ">> \"Décommenter\" la sélection" }
		bind .ficones.decommenter <Leave> {  .fetat.message configure -text "" }
		
		#icone Separateur
		label .ficones.separateur2b -relief groove -bd 2
		pack .ficones.separateur2b -side left
		
		#icone rechercher
		set imgRechercher [image create photo -file [file join $Chemin(rel) images find.gif]]
		button .ficones.rechercher -image $imgRechercher -relief flat -command {JVSeditor::ChoisirMot}
		pack .ficones.rechercher -side left
		bind .ficones.rechercher <Enter> {after 50; .fetat.message configure -text ">> Cherche une chaine verbale choisie ..."}
		bind .ficones.rechercher <Leave> { .fetat.message configure -text ""}
		
		#icone remplacer
		set imgRemplacer [image create photo -file [file join $Chemin(rel) images replace.gif]]
		button .ficones.remplacer -image $imgRemplacer -relief flat -command {JVSeditor::Remplacer $widtexte}
		pack .ficones.remplacer -side left
		bind .ficones.remplacer <Enter> {after 50  ; .fetat.message configure -text ">> Remplace une chaine verbale par une autre ..."}
		bind .ficones.remplacer <Leave> { .fetat.message configure -text ""}
		
		#icone allerLigne
		set imgNumeroterSelection [image create photo -file [file join $Chemin(rel) images icon_label.gif]]
		button .ficones.numeroterSelection  -image $imgNumeroterSelection	 -relief flat -command {JVSeditor::ChoisirLigne $widtexte} 		-bd 1
		pack .ficones.numeroterSelection -side left
		bind .ficones.numeroterSelection <Enter> {after 50 ; .fetat.message configure -text ">>Curseur positionné à la  ligne sélectionnée "}
		bind .ficones.numeroterSelection <Leave> { .fetat.message configure -text ""}
		
		#icone Separateur
		label .ficones.separateur3 -relief groove -bd 2
		pack .ficones.separateur3 -side left
		
		#icone tout selectionner
		set imgToutSelectionner [image create photo -file [file join $Chemin(rel) images anchor.gif]]
		button .ficones.toutSelectionner  -image $imgToutSelectionner  -relief flat -command {JVSeditor::ToutSelectionner $widtexte}
		pack .ficones.toutSelectionner -side left
		bind .ficones.toutSelectionner <Enter> {after 50  ; .fetat.message configure -text ">> Selectionne tout le texte <Ctrl+a>"}
		bind .ficones.toutSelectionner <Leave> { .fetat.message configure -text ""}
		
		#icone couper
		set imgCouper [image create photo -file [file join $Chemin(rel) images cut.gif]]
		button .ficones.couper  -image $imgCouper  -relief flat -command {JVSeditor::Couper $widtexte}
		pack .ficones.couper -side left
		bind .ficones.couper <Enter> {after 50 ; .fetat.message configure -text ">> Supprime le texte sélectionné et le mémorise dans le presse papier <Ctrl+x>"}
		bind .ficones.couper <Leave> {  .fetat.message configure -text ""}
		
		#icone copier
		set imgCopier [image create photo -file [file join $Chemin(rel) images copy.gif]]
		button .ficones.copier  -image $imgCopier  -relief flat -command {JVSeditor::Copier $widtexte}
		pack .ficones.copier -side left
		bind .ficones.copier <Enter> {after 50  ; .fetat.message configure -text ">> Copie le texte sélectionné dans le presse papier <Ctrl+c>"}
		bind .ficones.copier <Leave> { .fetat.message configure -text ""}
		
		#icone coller
		set imgColler [image create photo -file [file join $Chemin(rel) images paste.gif]]
		button .ficones.coller  -image $imgColler -relief flat -command {JVSeditor::Coller $widtexte}
		pack .ficones.coller -side left
		bind .ficones.coller <Enter> {after 50  ; .fetat.message configure -text ">> Insère le contenu du presse papier à la position du curseur <Ctrl+v>"}
		bind .ficones.coller <Leave> { .fetat.message configure -text ""}
		
		#<icone_cacher>
		set imgCacher [image create photo -file [file join $Chemin(rel) images masque.gif]]
		button .ficones.cacher  -image $imgCacher -relief flat -command {JVSeditor::MasquerSelection $widtexte}
		pack .ficones.cacher -side left
		bind .ficones.cacher <Enter> {after 50  ; .fetat.message configure -text ">> Masque le texte sélectionné"}
		bind .ficones.cacher <Leave> { .fetat.message configure -text ""}
		
		#icone Separateur
		label .ficones.separateur4 -relief groove -bd 2
		pack .ficones.separateur4 -side left
		
		#icone PolicePlus
		set imgPolicePlus [image create photo -file [file join $Chemin(rel) images incfont.gif]]
		button .ficones.policePlus  -image $imgPolicePlus -relief flat -command {JVSeditor::PolicePlus $widtexte}
		pack .ficones.policePlus  -side left
		bind .ficones.policePlus  <Enter> {after 50  ; .fetat.message configure -text ">> Augmente la taille des lettres"}
		bind .ficones.policePlus  <Leave> {  .fetat.message configure -text ""}
		
		#icone PoliceMoins
		set imgPoliceMoins  [image create photo -file [file join $Chemin(rel) images decrfont.gif]]
		button .ficones.policeMoins  -image $imgPoliceMoins  -relief flat -command {JVSeditor::PoliceMoins $widtexte}
		pack .ficones.policeMoins   -side left
		bind .ficones.policeMoins   <Enter> {after 50  ; .fetat.message configure -text ">> Diminue la taille des lettres"}
		bind .ficones.policeMoins   <Leave> {  .fetat.message configure -text ""}
		
		
		# icone Separateur
		label .ficones.separateur5 -relief groove -bd 2
		pack .ficones.separateur5 -side left
		
		
		#<iconesParticulieresJSeditor>  icones particulières à JSeditor
		
				
		#icone procs
		set imgProcs [image create photo -file [file join $Chemin(rel) images procs.gif]]
		button .ficones.procs  -image $imgProcs -relief flat -command {JVSeditor::AfficheListeProcs $widtexte} 
		pack .ficones.procs -side right
		bind .ficones.procs <Enter> {after 50  ; .fetat.message configure -text ">>Affiche les fonctions du script (ordre chrono) "}
		bind .ficones.procs <Leave> { .fetat.message configure -text ""}
		
		#icone procsAlpha
		set imgProcAlpha [image create photo -file [file join $Chemin(rel) images alpha.gif]]
		button .ficones.procsAlpha  -image $imgProcAlpha  -relief flat -command {JVSeditor::AfficheListeProcsAlpha $widtexte} 
		pack .ficones.procsAlpha  -side right
		bind .ficones.procsAlpha  <Enter> {after 50; .fetat.message configure -text ">>Affiche les fonctions du script (ordre alpha) "}
		bind .ficones.procsAlpha  <Leave> { .fetat.message configure -text ""}
		
		#icone Balises
		set imgBalises [image create photo -file [file join $Chemin(rel) images balises.gif]]
		button .ficones.balises  -image $imgBalises -relief flat -command {JVSeditor::AfficheListeBalises $widtexte}  
		pack .ficones.balises  -side right
		bind .ficones.balises  <Enter> {after 50  ; .fetat.message configure -text ">>Affiche les balises du script (ordre chrono) "}
		bind .ficones.balises  <Leave> {  .fetat.message configure -text ""}
		
		#icone colorierBalises
		set imgTagBalises [image create photo -file [file join $Chemin(rel) images balisesAncre.gif]]
		button .ficones.tagbalises  -background white -image $imgTagBalises -relief flat -command {JVSeditor::AlterneBalises $widtexte}  
		pack .ficones.tagbalises  -side right
		bind .ficones.tagbalises  <Enter> {after 50  ; .fetat.message configure -text ">>Formate ou déformate les balises du script  "}
		bind .ficones.tagbalises  <Leave> {  .fetat.message configure -text ""}
		
		
		#icone commentaires
		set imgCommentaire [image create photo -file [file join $Chemin(rel) images toglcom.gif]]
		button .ficones.commentaire  -image $imgCommentaire -relief flat -command {JVSeditor::PermuteCommentaireSpecial $widtexte} 
		pack .ficones.commentaire -side right
		bind .ficones.commentaire <Enter> {after 50  ; .fetat.message configure -text ">>(dé)Commente les lignes sélectionnées <Ctrl+k>"}
		bind .ficones.commentaire <Leave> {   .fetat.message configure -text ""}
		
		
		#icone coloration
		set imgColoration [image create photo -file [file join $Chemin(rel) images greenball.gif]]
		set imgColoration2 [image create photo -file [file join $Chemin(rel) images redball.gif]]
		button .ficones.coloration  -image $imgColoration	 -relief flat -command {
			
			#coloration des mots clefs;
			JVSeditor::Coloration $widtexte 1} 	-bd 4
		pack .ficones.coloration -side right
		bind .ficones.coloration <Enter> {after 50 ; .fetat.message configure -text ">>Lance la coloration de la syntaxe "}
		bind .ficones.coloration <Leave> { ; .fetat.message configure -text ""}
		
		#icone surcoloration
		set imgSurColoration [image create photo -file [file join $Chemin(rel) images surcolorier.gif]]
		
		button .ficones.surcoloration  -image $imgSurColoration	 -relief flat -command {JVSeditor::ChoixSurlignage $widtexte } 	-bd 4
		pack .ficones.surcoloration -side right
		bind .ficones.surcoloration <Enter> {after 50 ; .fetat.message configure -text ">>Permet de surcolorier des mots choisis"}
		bind .ficones.surcoloration <Leave> { ; .fetat.message configure -text ""}
		
	#<visionneuse>
		#icone visionneuse
		set imgVisionneuse [image create photo -file [file join $Chemin(rel) images visionneuse.gif]]
		button .ficones.visionneuse  -image $imgVisionneuse  -relief flat -command {JVSeditor::Visionneuse} 		-bd 2
		pack .ficones.visionneuse -side right
		bind .ficones.visionneuse <Enter> {after 50  ; .fetat.message configure -text ">>Voir des images... "}
		bind .ficones.visionneuse <Leave> { .fetat.message configure -text ""}
		
		#icone tampon
		set imgTampon [image create photo -file [file join $Chemin(rel) images tampon.gif]]
		button .ficones.tampon  -image $imgTampon  -relief flat -command {JVSeditor::Tampon $widtexte} 		-bd 2
		pack .ficones.tampon -side right
		bind .ficones.tampon <Enter> {after 50  ; .fetat.message configure -text ">>Inserer la sélection dans le menu tampon"}
		bind .ficones.tampon <Leave> { .fetat.message configure -text ""}
		
		#<icone_accollades>
		set imgAccollades [image create photo -file [file join $Chemin(rel) images accollades.gif]]
		button .ficones.accolade -image $imgAccollades  -relief flat -command {JVSeditor::CompteAccollades $widtexte} 		-bd 2
		pack .ficones.accolade  -side right
		bind .ficones.accolade  <Enter> {after 50 ; .fetat.message configure -text ">>Affiche l'accollade ou le crochet correspondant"}
		bind .ficones.accolade  <Leave> { .fetat.message configure -text ""}
		

					
		######################################################
		#<MENUS>
		######################################################
		
		#<MENUScLASSIQUE>  D'EDITION
		
		#MENU FICHIER
		$Fichier add command -label "Nouveau script" -accelerator Ctrl+n \
			-command 	 {JVSeditor::Nouveau }
		$Fichier add command -label "Ouvrir" -accelerator Ctrl+O \
			-command { JVSeditor::Ouvrir }
		
		$Fichier add cascade -label "Récents" -menu $Fichier.lRecents
		menu $Fichier.lRecents -tearoff 1
		JVSeditor::MaJMenuRecents
		
		$Fichier add command -label "Sauvegarder" -accelerator Ctrl+S \
			-command { JVSeditor::Sauvegarder $widtexte 0 }
		$Fichier add command -label "Sauvegarder sous..." -accelerator Ctrl+Shift+S \
			-command { JVSeditor::Sauvegarder $widtexte 1 }
		$Fichier add command -label "Fermer" -accelerator Ctrl+Shift+F \
			-command { JVSeditor::Fermer $widtexte }
		$Fichier add separator
		$Fichier add command -label "Quitter" -accelerator Ctrl+Q \
			-command JVSeditor::Quitter
		
		#MENU EDITER
		$Editer add command -label "Rechercher" \
			-command "JVSeditor::ChoisirMot "
		$Editer add command -label "Remplacer"\
			-command {JVSeditor::Remplacer $widtexte}
		$Editer add separator
		
		if {$tcl_version>=8.4} {
		  $Editer add command -label "Défaire" -accelerator Ctrl+Z\
			  -command { JVSeditor::Defaire $widtexte }
		  $Editer add command -label "Refaire" -accelerator Ctrl+E\
			  -command { JVSeditor::Refaire $widtexte }
		  $Editer add separator
		}
		
		$Editer  add command -label "Couper" -accelerator Ctrl+X\
			-command { JVSeditor::Couper $widtexte}
		$Editer  add command -label "Copier" -accelerator Ctrl+C\
			-command { JVSeditor::Copier $widtexte }
		$Editer  add command -label "Coller" -accelerator Ctrl+V\
			-command { JVSeditor::Coller $widtexte }
		$Editer add separator
		$Editer add command -label "Sélectionner tout" -accelerator Ctrl+A \
			-command { JVSeditor::ToutSelectionner $widtexte }
		
		#MENU OUTILS
		$Outils add command -label "Colorier la syntaxe" \
			-command { JVSeditor::Coloration $widtexte 1}
	#<MENU_cacher>
		$Outils add command -label "Masquer Sélection" -command {JVSeditor::MasquerSelection $widtexte} 	
		$Outils add command -label "Surcolorier" -command {JVSeditor::ChoixSurlignage $widtexte} 
		$Outils add command -label "Évaluation Tcl" -accelerator Ctrl+T\
			-command {JVSeditor::EvaluationTcl $widtexte }
		$Outils add command -label "Liste fonctions Chrono" \
			-command {  JVSeditor::AfficheListeProcs $widtexte }
		$Outils add command -label "Liste fonctions Alpha" \
			-command {  JVSeditor::AfficheListeProcsAlpha $widtexte }
		$Outils add command -label "Liste Balises" \
			-command {JVSeditor::AfficheListeBalises $widtexte}  
		$Outils add command -label "Visionneuse " \
			-command {JVSeditor::Visionneuse}
		$Outils add separator
		$Outils add command -label "Commenter sélection"\
			-command { JVSeditor::CommenterSelection $widtexte 1 }
		$Outils add command -label "Décommenter sélection"\
			-command { JVSeditor::CommenterSelection $widtexte 0 }
		$Outils add separator
		
		
		
		#MENU PAGES
		# on met à jour le menu Pages	 avec la page par défaut
		set choix  "défault"
		$Pages	add radio -label "page : 0" -command " JVSeditor::Affiche 0 $choix "
		
		
		#<MENU_PREFS>
		$Prefs add command -label "Purger \"menu récent\" " \
	  -command { JVSeditor::PurgerRecents  }
	  
	  $Prefs add separator
	  
		$Prefs add  cascade -label "Retour ligne" -menu $Prefs.menuRetourLigne
	 $Prefs add cascade -label "Barre d'état" -menu $Prefs.menuEtat
	$Prefs add cascade -label "Numéros lignes" -menu $Prefs.menuNumLignes
	  
	 $Prefs add separator
	$Prefs add command -label "Choix navigateur" \
	  -command {JVSeditor::ChoixNavigateur} 

	
		$Prefs add command -label "Choix couleurs" \
	  -command {JVSeditor::Couleurs}
	  
		$Prefs add separator
		$Prefs add command -label "Choix Fonte" \
			-command {JVSeditor::ChoixFonte }		
		$Prefs add command -label "augmenter Fonte" \
			-command {JVSeditor::PolicePlus $widtexte}
		$Prefs add command -label "diminuer Fonte" \
			-command {JVSeditor::PoliceMoins $widtexte}
		
		
		menu $Prefs.menuRetourLigne
		$Prefs.menuRetourLigne  	add radio -label "aucun" -variable wrap -value "none" -command {JVSeditor::RetourLigne none}
		$Prefs.menuRetourLigne  	add radio -label "char" -variable wrap -value "word" -command {JVSeditor::RetourLigne  char}
		$Prefs.menuRetourLigne  	add radio -label "mot" -variable wrap -value "char" -command {JVSeditor::RetourLigne  word}
		
		menu $Prefs.menuEtat
		$Prefs.menuEtat 	add radio -label "haut" -variable position -value "haut" -command {JVSeditor::BarreEtat haut}
		$Prefs.menuEtat 	add radio -label "bas" -variable position -value "bas" -command {JVSeditor::BarreEtat bas}
		
		menu $Prefs.menuNumLignes
		$Prefs.menuNumLignes  	add radio -label "oui" -variable position -value "haut" -command {$widtexte configure -linemap 1}
		$Prefs.menuNumLignes  	add radio -label "non" -variable position -value "bas" -command {$widtexte configure -linemap 0}
		
		 $Prefs add separator
		
		$Prefs add command -label "Sauver Config" \
			-command {JVSeditor::EnregConfig }
		
		
		#<MENU_AIDE>
		$Aide	add command -label "Au sujet de..."\
			-command " JVSeditor::AuSujetDe \[list \"JSeditor version\"  $version $ausujetdeDM  $ausujetdeJN  $ausujetdeSUCF \] "
		$Aide	add command -label "AIDE JSeditor"\
			-command  " JVSeditor::Aide \[list \"JSeditor version $version\" \] "
		$Aide	add command -label "AIDE Javascript"\
						-command  " JVSeditor::LancerNavigateur "
		$Aide add separator
		$Aide add command -label "expression régulière" -command {JVSeditor::ExpressionReguliere}
		
		
		# MENUS PARTICULIERS DE JSeditor
		#oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		# interface "gavarnie"
		#MENUS PARTICULIERS de JSeditor

		# interface gavarnie : fin
		#oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
		
		#<MENUcolor>
		$Color configure -background LightBlue  
		
		$Color add cascade	-label Nom	-menu "$Color.menuNom" -background LightBlue  
		menu $Color.menuNom -bg yellow
		set nomCouleur [list SteelBlue AntiqueWhite aquamarine azure beige bisque black BlueViolet brown chartreuse chocolate coral LightBlue DarkCyan\
			DarkGreen DarkGrey DarkRed DarkSalmon DeepPink DeepSkyBlue ForestGreen gray gray100 green GreenYellow\
			HotPink ivory  lavender LemonChiffon LightBlue LimeGreen maroon orange orchid pink plum purple RosyBrown salmon sienna\
			SteelBlue tan tomato turquoise violet white wheat yellow YellowGreen  ]
		set j 0
		
		# boucle de création de colonnes des menus cascade de "Widgets	"
		foreach élémentCouleur $nomCouleur {
		  if {$j==24} {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set commande [lindex $nomCouleur $j]
		  $Color.menuNom add radiobutton	-label $commande	-activebackground $commande -variable textComd -value $commande \
			  -command " \$widtexte insert insert {$commande } "  -columnbreak $optionColumnBreak   
		  
		  incr j
		}
		
		$Color add command	-label Choix	-background LightBlue  -command {$widtexte insert insert "[ tk_chooseColor ] " ;$widtexte insert insert " "}
	
		
#<MenuMotCles>

#<MenuEvenements>

set mots $motscles(evenement)
		
				
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Evenements add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}

#<OBJETS>
	 $Objets configure -background LightBlue  
		# list des commandes de controle .
		# Un sous menu au menu Motcles est créé, avec l'entrée : "controle" 
		
		set mots [ list  break case do continue for if in label switch while with return]
		
		 $Objets add cascade -label Controle -menu $Objets.controle 
		menu $Objets.controle 
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.controle add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
		# list des commandes objet
		# Un sous menu au menu Motcles est créé, avec l'entrée : "objet du noyau" 
		
		set mots [ list  Array Boolean Date Function Math Number Object RegExp String ]
		
		 $Objets add cascade -label "objets du noyau" -menu $Objets.objetNoyau
		menu $Objets.objetNoyau 
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.objetNoyau add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
		# list des commandes fenêtre
		# Un sous menu au menu Motcles est créé, avec l'entrée : "window" 
		
		set mots [ list  frame history location screen window ]
		
		 $Objets add cascade -label window -menu $Objets.window
		menu $Objets.window
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.window add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
		# list des commandes fenêtre
		# Un sous menu au menu Motcles est créé, avec l'entrée : "document" 
		
		set mots [ list  Anchor Applet Area document Image Layer Link ]
		
		 $Objets add cascade -label document -menu $Objets.document
		menu $Objets.document
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.document add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
		
		# list des commandes formulaire
		# Un sous menu au menu Motcles est créé, avec l'entrée : "formulaire" 
		
		set mots [ list  button checkbox fileUpload form hidden option password radio reset select submit text textarea  ]
		
		 $Objets add cascade -label formulaire -menu $Objets.formulaire
		menu $Objets.formulaire
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.formulaire add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
		# list des commandes navigateur
		# Un sous menu au menu Motcles est créé, avec l'entrée : "navigateur" 
		
		set mots [ list  MimeType navigator Plugin ]
		
		 $Objets add cascade -label navigateur -menu $Objets.navigateur
		menu $Objets.navigateur
		
		set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Objets.navigateur add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		  incr i
		}
		
#<ATTRIBUTS>		
		
		 $Attributs configure -background LightBlue  
		# établissement du menu Attributs, liste des objets de javascript
		
		 $Attributs add cascade -label "objets du noyau" -menu $Attributs.objetNoyau
		menu $Attributs.objetNoyau 		
		$Attributs.objetNoyau  configure -background LightBlue  
		
		 $Attributs add cascade -label "window" -menu $Attributs.window
		menu $Attributs.window
		$Attributs.window configure -background LightBlue  
		
		 $Attributs add cascade -label "document" -menu $Attributs.document
		menu $Attributs.document
		$Attributs.document configure -background LightBlue 
		
		 $Attributs add cascade -label "formulaire" -menu $Attributs.formulaire
		menu $Attributs.formulaire
		$Attributs.formulaire configure -background LightBlue 
		
		 $Attributs add cascade -label "navigateur" -menu $Attributs.navigateur
		menu $Attributs.navigateur
		$Attributs.navigateur configure -background LightBlue 
		
	
	
			
		#OBJETS DU NOYAU
		
		set mots [ list  array boolean date function math number object regExp string ]
		set entreeMenu $Attributs.objetNoyau
	
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $entreeMenu   add cascade 		-label $mot	  -menu $entreeMenu.$mot
		menu  $entreeMenu.$mot
		
		  incr i
		}
	

		
		#menu attributsArray
		set mots [ list length ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.objetNoyau.array add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributoolean
		set mots [ list prototype ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.objetNoyau.boolean add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsDate
		set mots [ list prototype ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		$Attributs.objetNoyau.date add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsFunction
		set mots [ list arguments\[\] arity caller length prototype ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.objetNoyau.function add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsMath
		set mots [ list E LN10 LN2 LOG10E LOG2E PI SQRT182 SQRT2 ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.objetNoyau.math add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsNumber
		set mots [ list {MAX_VALUE} {MIN _VALUE} NaN NEGATIVE_INFINITY POSITIVE_INFINITY]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.objetNoyau.number add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsObject
		set mots [ list constructor ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		$Attributs.objetNoyau.object add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsRegExp
		set mots [ list \$n \$ \$* \$& \$+ &\' \$\' global ignorecase input lastIndex lastMatch lastParen\
			 leftContext multiline rightContext source ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.objetNoyau.regExp add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsString
		set mots [ list length]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.objetNoyau.string add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
#<AttributWindow>
		
		#boucle pour les objets de window
		
		set mots [ list frame history location screen window]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.window add cascade -label $mot -menu $Attributs.window.$mot
		menu $Attributs.window.$mot
		  incr i
		}
		
		#menu attributFrame
		$Attributs.window.frame add radiobutton 		-label ""	 -background grey
		
		#menu attributHistory
			
		set mots [ list current length next previous]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.window.history add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributLocation
			
		set mots [ list hash host hostname href pathname port protocole search]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.window.location add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
	
	#menu attributScreen
			
		set mots [ list availHeight availWidth height pixelDepth width]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.window.screen add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributWindow
			
		set mots [ list closed defaultStatus document frames history innerHeight innerWidth length locaton menubar \
			name opener outerHeight outerWidth pageXOffset paaageYOffset parent personalbar scrollbars \
			self status statusbar toolbar top window ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.window.window add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
	
#<AttributDocument>
		
		#boucle pour les objets de document
		
		set mots [ list anchor applet area document image layer link]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.document add cascade -label $mot -menu $Attributs.document.$mot
		menu $Attributs.document.$mot
		
		  incr i
		}
		
		#menu attributsAnchor
		set mots [ list {aucun attribut} ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.anchor add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  		
		  incr i
		}	
		
		#menu attributsApplet
		set mots [ list {attributs publics de l'applet} ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.applet add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			 
			  incr i
		}	
		
		#menu attributsArea
		set mots [ list hash host hostname href port protocole search target text ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.area add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}	
		
		#menu attributsDocument
		set mots [ list alinkColor anchors appletts bgColor classes cookie domain embeds fgColor forms height ids\
			images lastModified layers links location plugins referrer tags title URL vlinkColor width]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.document add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}	
		
		#menu attributsImage
		set mots [ list border complete height hspace lowsrc name prototype src vspace width]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.image add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}	
		
		#menu attributsLayer
		set mots [ list background below bgcolor clip.bottom clip.height clip.left clip.right clip.top clip.width \
		document left name pageX pageY parentLayer siblingAbove siblingBelow src top visibility zIndex]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.layer add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}	
		
		#menu attributsLink
		set mots [ list hash host hostname href port protocole search target text ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.document.link add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}	
		
#<AttributFormulaire>
		
		#boucle pour les objets de formulaire
		
		set mots [ list button checkbox fileUpload form hidden option password radio reset select submit text textarea]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.formulaire add cascade -label $mot -menu $Attributs.formulaire.$mot
		menu $Attributs.formulaire.$mot
		
		  incr i
		}
		
		#menu attributsButton
		set mots [ list form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.button add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsCheckbox
		set mots [ list checked defaultChecked form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.checkbox add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsFileUpload
		set mots [ list form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.fileUpload add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsForm
		set mots [ list action elements encoding length method name target ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.form add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsHidden 
		set mots [ list form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.hidden add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsOption
		set mots [ list defaultSelected selected text value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.option add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsPassword
		set mots [ list defaultValue form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.password add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsRadio 
		set mots [ list checked defaultChecked form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.radio add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsReset
		set mots [ list form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.reset add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsSelect
		set mots [ list form length name options selectedIndex type]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.select add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsSubmit
		set mots [ list form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.submit add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsText
		set mots [ list defaultValue form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.text add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsTextarea
		set mots [ list defaultValue form name type value ]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.formulaire.textarea add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		
#<AttributNavigateur>
		
		#boucle pour les objets de navigateur
		
		set mots [ list mimeType navigator plugin]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		 $Attributs.navigateur add cascade -label $mot -menu $Attributs.navigateur.$mot
		menu $Attributs.navigateur.$mot
		
		  incr i
		}
		
		#menu attributsMimeType
		set mots [ list description enabledPlugin suffixes type]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.navigateur.mimeType add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsNavigator
		set mots [ list appCodeName appName appVersion language mimeTypes platform plugins userAgent]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.navigateur.navigator add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
		#menu attributsPlugin
		set mots [ list description filename length name]
		
		 set i 0
		foreach élément $mots {
		  if { ($i==25) || ($i==51) || ($i==77) || ($i==103) } {set optionColumnBreak 1
		  } else {set optionColumnBreak 0 }
		  set mot [lindex $mots $i]
		  $Attributs.navigateur.plugin add radiobutton 		-label $mot	 -background yellow -variable insertionMotcle -value $mot \
			  -command {$widtexte insert insert "$insertionMotcle "} -columnbreak $optionColumnBreak
		
		  incr i
		}
		
#<METHODES>



# établissement du menu Methodes,liste des objets de javascript
# création des entrées cascade,
 $Methodes configure -background LightBlue  
				
		 $Methodes add cascade -label "objets du noyau" -menu $Methodes.objetNoyau
		menu $Methodes.objetNoyau 
		$Methodes.objetNoyau  configure -background LightBlue  
		
		 $Methodes add cascade -label "window" -menu $Methodes.window
		menu $Methodes.window
		$Methodes.window configure -background LightBlue 
		
		 $Methodes add cascade -label "document" -menu $Methodes.document
		menu $Methodes.document
		$Methodes.document configure -background LightBlue  
		
		 $Methodes add cascade -label "formulaire" -menu $Methodes.formulaire
		menu $Methodes.formulaire
		$Methodes.formulaire configure -background LightBlue 
		
		 $Methodes add cascade -label "navigateur" -menu $Methodes.navigateur
		menu $Methodes.navigateur
		$Methodes.navigateur configure -background LightBlue 
		
#<MethodesobjetNoyau > 

		# list des commandes de 	 MethodesobjetNoyau 
		
		set mots [ list  array boolean date function math number object string regExp \"globales\" ]
		JVSeditor::boucleCascades $Methodes.objetNoyau $mots 15
		
		
		
		#boutons de array
		set mots [ list  concat() join() reverse() slice() sort()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.array $mots 15
		
		#boutons de boolean
		set mots [ list  toString()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.boolean $mots 15
		
		#boutons de date
		set mots [ list  getDate() getDay() getFullYear() getHours() getMilliseconds() getMinutes() getMonth() getSeconds() \
			getTime() getTimezoneOffset() getUTCDate() getUTCDay() getUTCFullYear() getUTCHours()  getUTCMilliseconds \
			getUTCMinutes() getUTCMonth() getUTCSeconds() getYear() parse() setDate() setFullYear() setHours() setMilliseconds() \
			setMinutes() setMonth() setSeconds() setTime() setUTCDate() setUTCFullYear() setUTCHours()	setUTCMilliseconds() \
			setUTCMinutes() setUTCMonth() setUTCSeconds() setYear() toGMTString() toLocaleString() toStrinbg() toUTCString() UTC()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.date $mots 20

		#boutons de function
		set mots [ list  apply() toString()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.function $mots 15
		
		#boutons de Math
		set mots [ list  abs() acos() asin() atan() atan2() ceil() cos() exp() floor() log() \
					max() min() pow() random() round() sin() sqrt() tan()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.math $mots 9
		
		#boutons de Number
		set mots [ list  toString()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.number $mots 15
		
		#boutons de object
		set mots [ list assign() eval() toString() unwatch() valueOf()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.object $mots 15
		
		#boutons de string
		set mots [ list anchor() big() blink() bold() charAt() charCodeAt() concat() fixed() fotcolor() fontsize() indexOf() \
			italics() lastIndexOf() link() match() replace() search() slice() small() split() strike() sub() substr() \
			substring() sup() toLowerCase() toUpperCase()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.string $mots 14
		
		#boutons de regExp
		set mots [ list compile() exec() test()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.regExp $mots 15
		
		#boutons de methodesGlobales
		set mots [ list escape() eval() isFinite() isNan() parseInt() parseFloat() toString()]
		JVSeditor::boucleBoutons $Methodes.objetNoyau.\"globales\" $mots 15
		
#<MethodesWindow>
		# list des commandes de 	 MethodesWindow
		
		set mots [ list  frame history location screen window ]
		JVSeditor::boucleCascades $Methodes.window $mots 15
		
		#boutons de methodesFrame
		$Methodes.window.frame add radiobutton 		-label ""	 -background grey
		
		#boutons de methodesHistory
		set mots [ list back() forward() go() ]
		JVSeditor::boucleBoutons $Methodes.window.history $mots 15
		
		#boutons de methodesLocation
		set mots [ list reload() replace() ]
		JVSeditor::boucleBoutons $Methodes.window.location $mots 15
		
		#boutons de methodesScreen
		$Methodes.window.screen add radiobutton 		-label {''"}	 -background grey
		
		
		#boutons de methodesWindow
		set mots [ list alert() back() blur() captureEvents() clearInterval() clearTimeout() close() confirm() \
		 disableExternalCapture() enableExternalCapture() find() focus() forward() handleEvent()  home() \
		 moveBy() moveTo() open() print() prompt() releaseEvents() resizeBy() resizeTo() routeEvent() \
		 scroll() scrollBy() srollTo() setInterval() setTimeout () stop()  ]
		JVSeditor::boucleBoutons $Methodes.window.window $mots 16
		

#<MethodesDocument>
		# list des commandes de 	 MethodesDocument
		
		set mots [ list  anchor applet area document image layer link]
		JVSeditor::boucleCascades $Methodes.document $mots 15
		
		#boutons de methodesAnchor
		$Methodes.document.anchor add radiobutton 		-label ''"	 -background grey
		
		#boutons de methodesApplet
		$Methodes.document.applet add radiobutton 		-label {''méthodes publiques de l'applet"}	 -background grey
		
		#boutons de methodesArea 
		set mots [ list "handleEvent()" ]
		JVSeditor::boucleBoutons $Methodes.document.area $mots 15
		
		#boutons de methodesDocument 
		set mots [ list captureEvents() clear() close() getSelection() handleEvents() open() releaseEvents() routeEvent() write() writeln() ]
		JVSeditor::boucleBoutons $Methodes.document.document $mots 15
		
		#boutons de methodesImage
		set mots [ list handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.document.image $mots 15
		
		#boutons de methodesLayer
		set mots [ list captureEvents() handleEvents() load() moveAbove() moveBelow() moveBy() moveTo() \
		moveToAbsolute() releaseEvents() resizeBy() resizeTo() routeEvent()]
		JVSeditor::boucleBoutons $Methodes.document.layer $mots 15
		
		#boutons de methodesLink
		set mots [ list "handleEvent()" ]
		JVSeditor::boucleBoutons $Methodes.document.link $mots 15
		
	
#<MethodesFormualire>
		# list des commandes de 	 MethodesFormulaire
		
		set mots [ list  button checkbox fileUpload form hidden option password radio reset select submit text textarea ]
		JVSeditor::boucleCascades $Methodes.formulaire $mots 15
		
		#boutons de methodesButton
		set mots [ list blur() click() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.button $mots 15
		
		#boutons de methodesCheckbox
		set mots [ list blur() click() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.checkbox $mots 15
		
		#boutons de methodesFileUpload
		set mots [ list blur() focus() handleEvent() select()]
		JVSeditor::boucleBoutons $Methodes.formulaire.fileUpload $mots 15
		
		#boutons de methodesForm
		set mots [ list handleEvent() select() submit()]
		JVSeditor::boucleBoutons $Methodes.formulaire.form $mots 15
		
		#boutons de methodesHidden
		$Methodes.formulaire.hidden add radiobutton 		-label ""	 -background grey
		
		#boutons de methodesOption
		$Methodes.formulaire.option add radiobutton 		-label ""	 -background grey
				
		#boutons de methodesPassword
		set mots [ list blur() focus() handleEvent() select()]
		JVSeditor::boucleBoutons $Methodes.formulaire.password $mots 15
			
		#boutons de methodesRadio
		set mots [ list blur() click() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.radio $mots 15
		
		#boutons de methodesReset
		set mots [ list blur() click() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.reset $mots 15
		
		#boutons de methodesSelect
		set mots [ list blur() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.select $mots 15
		
		#boutons de methodesSubmit
		set mots [ list blur() click() focus() handleEvent() ]
		JVSeditor::boucleBoutons $Methodes.formulaire.submit $mots 15
		
		#boutons de methodesText
		set mots [ list blur() focus() handleEvent() select()]
		JVSeditor::boucleBoutons $Methodes.formulaire.text $mots 15
		
		#boutons de methodesTextarea
		set mots [ list blur() focus() handleEvent() select()]
		JVSeditor::boucleBoutons $Methodes.formulaire.textarea $mots 15
				

#<MethodesNavigateur>
		# liste des commandes de 	 MethodesNavigateur
		
		set mots [ list  mimeType navigator plugin ]
		JVSeditor::boucleCascades $Methodes.navigateur $mots 15
		
		#boutons de methodesMimeType
		$Methodes.navigateur.mimeType add radiobutton 		-label ""	 -background grey
		
		#boutons de methodesNavigator
		set mots [ list javaEnabled() plugins.refresh() preference() taintEnabled() ]
		JVSeditor::boucleBoutons $Methodes.navigateur.navigator $mots 15
		
		#boutons de methodesPlugin
		$Methodes.navigateur.plugin add radiobutton 		-label ""	 -background grey
		

#------------------------------------ fin des boucles des menus motsclés ----------------------------------------		
	
	
#<MENUtampon>
		$Tampon configure -background #b6d9d9    
		$Tampon add command	-label "Vider tampon"	-command {.menubar.mTampon add separator ; .menubar.mTampon delete 2 end}  -foreground red
		
		
	#<BARREetat> BARRE D'ETAT
		
		frame .fetat -bd 2 -relief flat
		pack .fetat -fill both -before .ftext
		
		
		
		label .fetat.fichier -anchor w -relief sunken -foreground red -bg #e3f4d8   	-width 17 -font {courrier 8} -text $choix 
		label .fetat.message -anchor w -relief sunken -foreground red -bg yellow -width 28 -font {courrier 8}
		label .fetat.nblignes -width 22 -anchor e -relief sunken -bg YellowGreen   -font {courrier 8}
		label .fetat.taille  -width 12 -anchor e -relief sunken -bg YellowGreen   -font {courrier 8}
		
		pack .fetat.fichier -ipadx 8 -side left -fill x -expand true
		pack .fetat.message -ipadx 8 -side left -fill x -expand true
		pack .fetat.nblignes -ipadx 8 -side left
		pack .fetat.taille -ipadx 8 -side right
		
		if { ! [ string compare $tcl_platform(platform) "unix" ] } {
		  bind Text <Control-v> {}
		}
		
#<BIND> liste des actions liées au claier et à la souris 
		
		bind . <Control-o> { JVSeditor::Ouvrir $widtexte}
		bind . <Control-s> { JVSeditor::Sauvegarder $widtexte 0 }
		bind . <Shift-Control-Key-S> { JVSeditor::Sauvegarder $widtexte 1 }
		bind . <Control-Key-f> { JVSeditor::Fermer $widtexte }
		bind . <Control-q> JVSeditor::Quitter
		
		bind . <Control-a> { JVSeditor::ToutSelectionner $widtexte}
		
		#bind . <Control-2> {JVSeditor::CommenterSelection $widtexte1}
		
		
		bind . <Control-i> {JVSeditor::Indenter $widtexte }
		bind . <Control-C>	 JVSeditor::Couper
		bind $widtexte <3> { tk_popup .menubar.mEditer %X %Y } 
		bind . <KeyPress-Escape> {JVSeditor::EscapePermute $widtexte}
		
		bind . <KeyPress-space>  { JVSeditor::Coloration $widtexte 0 ; JVSeditor::NbLignes $widtexte .fetat.nblignes	}
		bind . <Control-Shift_L> { JVSeditor::Coloration $widtexte 0 ; JVSeditor::NbLignes $widtexte .fetat.nblignes	}
		bind . <Control-Shift_R> { JVSeditor::Coloration $widtexte 0 ; JVSeditor::NbLignes $widtexte .fetat.nblignes	}
		bind . <KeyPress-Return> { JVSeditor::IndentationAuto $widtexte ; \
			JVSeditor::NbLignes $widtexte .fetat.nblignes ; JVSeditor::NumeroLignesTexte $widtexte }
		bind . <KeyPress-Delete> {JVSeditor::NbLignes $widtexte .fetat.nblignes ; }
		bind . <KeyPress-BackSpace> {JVSeditor::NbLignes $widtexte .fetat.nblignes ;  }
		
	  }
	  
proc JVSeditor::AuSujetDe { var } {
		variable application
		variable ausujetdeDM ;#auteur de Javascripeditor
		variable ausujetdeJN ;#auteur visionneuse
		variable ausujetdeSUCF;#auteurs des routines html
		
		if [winfo exists .aPropos] {destroy .aPropos}
		toplevel .aPropos
		wm title .aPropos "Au sujet de $application"
		wm resizable .aPropos false false
		frame .aPropos.f -relief groove -border 2 -bg bisque
		pack .aPropos.f -padx 4 -pady 4 -ipadx 4 -ipady 4
		
		set i 0
		foreach item $var {
		  label .aPropos.f.$i -text $item -bg bisque 
		  pack .aPropos.f.$i -anchor w
		  incr i
		}
		
		bind .aPropos  <Enter> { destroy .aPropos  }
		set x0 [ expr ( [winfo width .] - [winfo reqwidth .aPropos ] ) / 2 +60]
		set y0 [ expr ( [winfo height .] - [winfo reqheight .aPropos ] ) / 2]
		wm geometry .aPropos  +[ expr [winfo x .]+ $x0 ]+[ expr [winfo y .] + 30 ] 
		
	  }
	  
	  # dévellopement de l'aide : affichage du fichier "aide_JSeditor.txt" dans un toplevel
	
proc JVSeditor::Aide { var } {
		variable application
		variable version
		global Chemin
		
		
		if [winfo exists .aide] {	destroy .aide}
		toplevel .aide
		bell -displayof .aide
		wm title .aide "Aide $application $version"
		wm resizable .aide true true


#<interfaceAide>

frame .aide.f
	pack .aide.f -side top
	label .aide.f.labelFonte -text " Taille des caractères "
	label .aide.f.reclic -text "Rechargez la page après modification de la taille des caractères"
	button .aide.f.plus -text " + " -command { JVSeditor::PolicePlusAide .aide.fenetreHtm}
	  button .aide.f.moins -text " _ " -command { JVSeditor::PoliceMoinsAide .aide.fenetreHtm}
	  pack .aide.f.labelFonte .aide.f.plus .aide.f.moins  .aide.f.reclic -side left


text .aide.sommaire -background lavender  -foreground BlueViolet -width 18 -height 15 -cursor arrow  -font  {helvetica 12}
text .aide.fenetreHtm -height 15 -font  {times 10}	-width 50 -yscrollcommand " .aide.y set"
scrollbar .aide.y -orient vertical -command {.aide.fenetreHtm yview} 
pack .aide.sommaire .aide.fenetreHtm   -expand true	-fill y  -side left 
pack .aide.y  -expand true  -fill y  -side left

wm resizable .aide false true
	
#<tags_sommaire>
foreach tag {t0 t1 t2 t3 t4 t5 t6 t7 t8 t9} {
	.aide.sommaire tag bind $tag <Any-Enter> ".aide.sommaire tag configure $tag -foreground white -background  RosyBrown " 
	.aide.sommaire tag bind $tag <Any-Leave> ".aide.sommaire tag configure $tag -foreground BlueViolet  -background  lavender"
}

#<insertion_sommaire>
.aide.sommaire insert end "Aide \n" t0
.aide.sommaire  insert end "Généralités \n" t1
.aide.sommaire  insert end "Menus \n" t2
.aide.sommaire  insert end "Menus classiques\n" t3
.aide.sommaire  insert end "Menus spéciaux\n" t4
.aide.sommaire  insert end "Icônes \n" t5
.aide.sommaire  insert end "Touches magiques\n" t6
 .aide.sommaire  insert end "Balises\n" t7 
.aide.sommaire  insert end "Masques\n" t8
.aide.sommaire  insert end "Colorisation\n" t9
.aide.sommaire  insert end "Barre d'informations\n" t10


#<liens_tags_fichiersHtml>

set fichierHtml [ open  [file join $Chemin(rel) aide accueil.html] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml

HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "

.aide.sommaire  tag bind t0 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide accueil.html] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm ;  HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t1 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide generalites.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t2 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide menus.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}

.aide.sommaire  tag bind t3 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide menus_classiques.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}

.aide.sommaire  tag bind t4 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide menus_programmation.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}


.aide.sommaire  tag bind t5 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide icones.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t6 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide touchesMagiques.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t7 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide balises.html] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t8 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide masque.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t9 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide colorisation.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t10 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide barreEtat.html ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }




bind .aide.sommaire  <3> { destroy .aide}
bind  .aide.fenetreHtm  <3> { destroy .aide}

		return 0
	  }
		
	
	
############################################################################	
#<Routines_html>
#
# ces fonctions sont issues de l'exemple fourni par l'auteur des routines d'affichage Html.2
# les commentaires en anglais sont les originaux. 
#
############################################################################

# Go render a page.  We have to make sure we don't render one page while
# still rendering the previous one.  If we get here from a recursive 
# invocation of the event loop, cancel whatever we were rendering when
# we were called.
# If we have a fragment name, try to go there.

proc render {file} {
	global HM.aideJavascript.texte Url
	global Running message

	set fragment ""
	regexp {([^#]*)#(.+)} $file dummy file fragment
	if {$file == "" && $fragment != ""} {
		HMgoto .aideJavascript.texte  $fragment
		return
	}
	HMreset_win .aideJavascript.texte
	set Running "EN COURS"
	set message "AFFICHAGE DE $file"
	update idletasks
	if {$fragment != ""} {
		HMgoto .aideJavascript.texte $fragment
	}
	set Url $file
	HMparse_html [get_html $file] {HMrender .aideJavascript.texte}
	set Running PRËT
	HMset_state .aideJavascript.texte -stop 1	;# stop rendering previous page if buzy 
	set message ""
}

# given a file name, return its html, or invent some html if the file can't
# be opened.

proc get_html {file} {
	global Home
		
	if {[catch {set fd [open $file]} msg]} {
		return "
			<title>Bad file $file</title>
			<h1>Error reading $file</h1><p>
			$msg<hr>
			<a href=$Home>Go home</a>
		"
	}
	set result [read $fd]
	close $fd
	return $result
}

# Override the library link-callback routine for the sample app.
# It only handles the simple cases.

proc HMlink_callback {win href} {
	global Url
	
	if {[string match #* $href]} {
		render $href
		return
	}
	if {[string match /* $href]} {
		set Url $href
	} else {
		set Url [file dirname $Url]/$href
	}
	update
	render $Url
}


# downloading fonts can take a long time.  We'll override the default
# font-setting routine to permit better user feedback on fonts.  We'll
# keep our own list of installed fonts on the side, to guess when delays
# are likely

proc HMset_font {win tag font} {
	global message Fonts
	if {![info exists Fonts($font)]} {
		set Fonts($font) 1
	set message "downloading font $font"
		update
		
	}
	set message ""
	catch {$win tag configure $tag -font $font} message
	
}

# Supply an image callback function
# Read in an image if we don't already have one
# callback to library for display

proc HMset_image {win handle src} {
	global Url message
	if {[string match /* $src]} {
		set image $src
	} else {
		set image [file dirname $Url]/$src
	}
	set message "fetching image $image"
	update
	if {[string first " $image " " [image names] "] >= 0} {
		HMgot_image $handle $image
	} else {
		set type photo
		if {[file extension $image] == ".bmp"} {set type bitmap}
		catch {image create $type $image -file $image} image
		HMgot_image $handle $image
	}
}

# Handle base tags.  This breaks if more than 1 base tag is in the document

proc HMtag_base {win param text} {
	global Url
	upvar #0 HM$win var
	HMextract_param $param href Url
}

# Lets invent a new HTML tag, just for fun.
# Change the color of the text. Use html tags of the form:
# <color value=blue> ... </color>
# We can invent a new tag for the display stack.  If it starts with "T"
# it will automatically get mapped directly to a text widget tag.

proc HMtag_color {win param text} {
	upvar #0 HM$win var
	set value bad_color
	HMextract_param $param value
	$win tag configure $value -foreground $value
	HMstack $win "" "Tcolor $value"
}

proc HMtag_/color {win param text} {
	upvar #0 HM$win var
	HMstack $win / "Tcolor {}"
}

##########################################################################
proc JVSeditor::ChoixNavigateur {} {
	global navigateur
	set navigateur [tk_getOpenFile  -title "choix navigateur" ]

	}
	  
proc JVSeditor::LancerNavigateur {} {
	global navigateur ;
	global Chemin
	set navigateur "firefox"
	
	if {$navigateur == ""} {
	tk_messageBox -message "Vous n'avez pas encore défini de navigateur! Utilisez le menu PREFS" } else {
	
	set aideIndex "http://jchr.be/html/javascript.htm"; 
	exec $navigateur $aideIndex & }
	} 
	#ANCIENNE VERSION AIDE  SUR LE JAVASCRIPT
#£ proc JVSeditor::AideJavascript { var } {
#£ 		variable application
#£ 		variable version
#£ 		global Chemin
#£ 		global Size
#£ 		
#£ 		
#£ if [winfo exists .aideJavascript] {	destroy .aideJavascript}
#£ 		toplevel .aideJavascript
#£ 		bell -displayof .aideJavascript
#£ 		wm title .aideJavascript "Aide Javascript $application $version"
#£ 		
#£ 		wm geometry .aideJavascript [expr ([winfo screenwidth . ]*9/10) ]x[expr ( [winfo screenheight . ] *9/10 ) ]+10+30
#£ 		wm resizable .aideJavascript true true
#£ 		
#£ 		
#£ 	frame .aideJavascript.f
#£ 	pack .aideJavascript.f -side top
#£ 	label .aideJavascript.f.msg -textvariable message -fg red
#£ 	
#£ 		
#£ 	label .aideJavascript.f.labelFonte -text " Taille des caractères "	-relief raised 
#£ 	button .aideJavascript.f.plus -text " + " -command { JVSeditor::PolicePlusAide .aideJavascript.texte}
#£ 	button .aideJavascript.f.moins -text " _ " -command { JVSeditor::PoliceMoinsAide .aideJavascript.texte}
#£ 	pack	.aideJavascript.f.labelFonte .aideJavascript.f.plus .aideJavascript.f.moins  -side left
#£ 	button .aideJavascript.f.index -text INDEX -command { global Chemin ;set Home [file join $Chemin(rel) aidehtml index.html]  ; 
#£ 								render $Home }
#£ 																																	
#£ 	entry .aideJavascript.f.entry  -textvariable Url -width 35	 		-bg white
#£ 	pack .aideJavascript.f.entry  .aideJavascript.f.msg -side left
#£ 	
#£ 	pack .aideJavascript.f.index -side left  
#£ 	
#£ 	
#£ 		text .aideJavascript.texte -bg LemonChiffon -relief groove -bd 6 -setgrid 1\
#£ 			-wrap word -yscrollcommand ".aideJavascript.scrolly set" -xscrollcommand ".aideJavascript.scrollx set" \
#£ 			-cursor hand2 -font {times 10} 
#£ 		scrollbar .aideJavascript.scrolly -orient vertical -command ".aideJavascript.texte yview" \
#£ 			-background #c0d9d9 -activebackground #c0d964 -troughcolor #c06664  
#£ 		scrollbar .aideJavascript.scrollx -orient horizontal -command ".aideJavascript.texte xview" \
#£ 			-background #c0d9d9 -activebackground #c0d964  -troughcolor #c06664  
#£ 		pack .aideJavascript.scrollx -padx 0 -pady 0 -ipadx 0 -ipady 0  -fill x 
#£ 		pack  .aideJavascript.texte -padx 0 -pady 0 -ipadx 0 -ipady 0 -side right -fill both -expand true
#£ 		
#£ 		pack .aideJavascript.scrolly -padx 0 -pady 0 -ipadx 0 -ipady 0 -side right -fill y
#£ 		
#£ 		bind .aideJavascript <ButtonPress-3> { destroy .aide}
#£ 		
#£ 		set x0 [ expr ( [winfo width .] - [winfo reqwidth .aideJavascript] ) / 2 ]
#£ 		set y0 [ expr ( [winfo height .] - [winfo reqheight .aideJavascript] ) / 2 ]
#£ 		
#£ 		bind .aideJavascript <3> { destroy .aideJavascript } 
#£ 	
#£ 	# set up some sample keyboard bindings for the text widget
#£ 	bind .aideJavascript.f.entry <Return> {render $Url}
#£ 	
#£ #<valeurs_initiales>
#£ 
#£ # set initial values
#£ set Size 0				;# font size adjustment
#£ set Indent 0.5			;# tab spacing (cm)
#£ set Home [pwd]/aidehtml/index.html		;# home document
#£ set Url $Home				;# current file
#£ set Running busy			;# page status
#£ set message ""				;# message line
#£ 
#£ HMinit_win .aideJavascript.texte
#£ HMset_state .aideJavascript.texte -size $Size
#£ HMset_indent .aideJavascript.texte $Indent
#£  render $Home
#£ HMoptimize 
#£ 		
#£ 		return 0
#£ 	  }
	  
	  
# LANCEMENT DE JSeditor	  
	  
 	  catch {JVSeditor::LectureConfig}
	  catch {JVSeditor::LectureListeRecents}
	  JVSeditor::Gui
	 after 50 catch raise .initiation 
	
	. configure   -highlightthickness 4 -highlightcolor #d9d979   -highlightbackground   #fbff26   
	
	after 10000 destroy .initiation 


#FIN de JSeditor
	  
	  
